/* xnoise-data-source.c generated by valac 0.16.0, the Vala compiler
 * generated from xnoise-data-source.vala, do not modify */

/* xnoise-data-source.vala
 *
 * Copyright (C) 2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define XNOISE_TYPE_DATA_SOURCE (xnoise_data_source_get_type ())
#define XNOISE_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_DATA_SOURCE, XnoiseDataSource))
#define XNOISE_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_DATA_SOURCE, XnoiseDataSourceClass))
#define XNOISE_IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_DATA_SOURCE))
#define XNOISE_IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_DATA_SOURCE))
#define XNOISE_DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_DATA_SOURCE, XnoiseDataSourceClass))

typedef struct _XnoiseDataSource XnoiseDataSource;
typedef struct _XnoiseDataSourceClass XnoiseDataSourceClass;
typedef struct _XnoiseDataSourcePrivate XnoiseDataSourcePrivate;

#define XNOISE_TYPE_TRACK_DATA (xnoise_track_data_get_type ())
#define XNOISE_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackData))
#define XNOISE_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))
#define XNOISE_IS_TRACK_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_IS_TRACK_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_TRACK_DATA))
#define XNOISE_TRACK_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_TRACK_DATA, XnoiseTrackDataClass))

typedef struct _XnoiseTrackData XnoiseTrackData;
typedef struct _XnoiseTrackDataClass XnoiseTrackDataClass;

#define XNOISE_TYPE_ITEM (xnoise_item_get_type ())

#define XNOISE_TYPE_ITEM_TYPE (xnoise_item_type_get_type ())
typedef struct _XnoiseItem XnoiseItem;

typedef enum  {
	XNOISE_ITEM_TYPE_UNKNOWN = 0,
	XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK,
	XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK,
	XNOISE_ITEM_TYPE_STREAM,
	XNOISE_ITEM_TYPE_CDROM_TRACK,
	XNOISE_ITEM_TYPE_PLAYLIST,
	XNOISE_ITEM_TYPE_LOCAL_FOLDER,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR,
	XNOISE_ITEM_TYPE_LOADER,
	XNOISE_ITEM_TYPE_CUSTOM_DATA_COL_ID,
	XNOISE_ITEM_TYPE_MAXCOUNT
} XnoiseItemType;

struct _XnoiseItem {
	XnoiseItemType type;
	guint32 stamp;
	gint32 db_id;
	gchar* uri;
	gchar* text;
	gint source_id;
};

struct _XnoiseDataSource {
	GObject parent_instance;
	XnoiseDataSourcePrivate * priv;
	gint source_id;
};

struct _XnoiseDataSourceClass {
	GObjectClass parent_class;
	const gchar* (*get_datasource_name) (XnoiseDataSource* self);
	gboolean (*get_trackdata_for_uri) (XnoiseDataSource* self, gchar** uri, XnoiseTrackData** val);
	XnoiseItem* (*get_artists_with_search) (XnoiseDataSource* self, const gchar* searchtext, int* result_length1);
	XnoiseTrackData** (*get_trackdata_by_artistid) (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
	XnoiseItem* (*get_artistitem_by_artistid) (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp);
	XnoiseTrackData** (*get_trackdata_by_albumid) (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
	XnoiseItem* (*get_albums_with_search) (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
	XnoiseTrackData* (*get_trackdata_by_titleid) (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp);
	gboolean (*get_stream_td_for_id) (XnoiseDataSource* self, gint32 id, XnoiseTrackData** tmp, guint32 stamp);
	XnoiseTrackData** (*get_all_tracks) (XnoiseDataSource* self, const gchar* searchtext, int* result_length1);
};


static gpointer xnoise_data_source_parent_class = NULL;

GType xnoise_data_source_get_type (void) G_GNUC_CONST;
gpointer xnoise_track_data_ref (gpointer instance);
void xnoise_track_data_unref (gpointer instance);
GParamSpec* xnoise_param_spec_track_data (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void xnoise_value_set_track_data (GValue* value, gpointer v_object);
void xnoise_value_take_track_data (GValue* value, gpointer v_object);
gpointer xnoise_value_get_track_data (const GValue* value);
GType xnoise_track_data_get_type (void) G_GNUC_CONST;
GType xnoise_item_get_type (void) G_GNUC_CONST;
GType xnoise_item_type_get_type (void) G_GNUC_CONST;
XnoiseItem* xnoise_item_dup (const XnoiseItem* self);
void xnoise_item_free (XnoiseItem* self);
void xnoise_item_copy (const XnoiseItem* self, XnoiseItem* dest);
void xnoise_item_destroy (XnoiseItem* self);
enum  {
	XNOISE_DATA_SOURCE_DUMMY_PROPERTY
};
void xnoise_data_source_set_source_id (XnoiseDataSource* self, gint id);
gint xnoise_data_source_get_source_id (XnoiseDataSource* self);
const gchar* xnoise_data_source_get_datasource_name (XnoiseDataSource* self);
static const gchar* xnoise_data_source_real_get_datasource_name (XnoiseDataSource* self);
gboolean xnoise_data_source_get_trackdata_for_uri (XnoiseDataSource* self, gchar** uri, XnoiseTrackData** val);
static gboolean xnoise_data_source_real_get_trackdata_for_uri (XnoiseDataSource* self, gchar** uri, XnoiseTrackData** val);
XnoiseItem* xnoise_data_source_get_artists_with_search (XnoiseDataSource* self, const gchar* searchtext, int* result_length1);
static XnoiseItem* xnoise_data_source_real_get_artists_with_search (XnoiseDataSource* self, const gchar* searchtext, int* result_length1);
XnoiseTrackData** xnoise_data_source_get_trackdata_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
static XnoiseTrackData** xnoise_data_source_real_get_trackdata_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
XnoiseItem* xnoise_data_source_get_artistitem_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp);
static XnoiseItem* xnoise_data_source_real_get_artistitem_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp);
XnoiseTrackData** xnoise_data_source_get_trackdata_by_albumid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
static XnoiseTrackData** xnoise_data_source_real_get_trackdata_by_albumid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
XnoiseItem* xnoise_data_source_get_albums_with_search (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
static XnoiseItem* xnoise_data_source_real_get_albums_with_search (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
XnoiseTrackData* xnoise_data_source_get_trackdata_by_titleid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp);
static XnoiseTrackData* xnoise_data_source_real_get_trackdata_by_titleid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp);
gboolean xnoise_data_source_get_stream_td_for_id (XnoiseDataSource* self, gint32 id, XnoiseTrackData** tmp, guint32 stamp);
static gboolean xnoise_data_source_real_get_stream_td_for_id (XnoiseDataSource* self, gint32 id, XnoiseTrackData** tmp, guint32 stamp);
XnoiseTrackData** xnoise_data_source_get_all_tracks (XnoiseDataSource* self, const gchar* searchtext, int* result_length1);
static XnoiseTrackData** xnoise_data_source_real_get_all_tracks (XnoiseDataSource* self, const gchar* searchtext, int* result_length1);
XnoiseDataSource* xnoise_data_source_construct (GType object_type);
static void xnoise_data_source_finalize (GObject* obj);


void xnoise_data_source_set_source_id (XnoiseDataSource* self, gint id) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = id;
	self->source_id = _tmp0_;
}


gint xnoise_data_source_get_source_id (XnoiseDataSource* self) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->source_id;
	result = _tmp0_;
	return result;
}


static const gchar* xnoise_data_source_real_get_datasource_name (XnoiseDataSource* self) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_datasource_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


const gchar* xnoise_data_source_get_datasource_name (XnoiseDataSource* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_datasource_name (self);
}


static gboolean xnoise_data_source_real_get_trackdata_for_uri (XnoiseDataSource* self, gchar** uri, XnoiseTrackData** val) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_trackdata_for_uri'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean xnoise_data_source_get_trackdata_for_uri (XnoiseDataSource* self, gchar** uri, XnoiseTrackData** val) {
	g_return_val_if_fail (self != NULL, FALSE);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_trackdata_for_uri (self, uri, val);
}


static XnoiseItem* xnoise_data_source_real_get_artists_with_search (XnoiseDataSource* self, const gchar* searchtext, int* result_length1) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_artists_with_search'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseItem* xnoise_data_source_get_artists_with_search (XnoiseDataSource* self, const gchar* searchtext, int* result_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_artists_with_search (self, searchtext, result_length1);
}


static XnoiseTrackData** xnoise_data_source_real_get_trackdata_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_trackdata_by_artistid'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseTrackData** xnoise_data_source_get_trackdata_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_trackdata_by_artistid (self, searchtext, id, stamp, result_length1);
}


static XnoiseItem* xnoise_data_source_real_get_artistitem_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_artistitem_by_artistid'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseItem* xnoise_data_source_get_artistitem_by_artistid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_artistitem_by_artistid (self, searchtext, id, stamp);
}


static XnoiseTrackData** xnoise_data_source_real_get_trackdata_by_albumid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_trackdata_by_albumid'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseTrackData** xnoise_data_source_get_trackdata_by_albumid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_trackdata_by_albumid (self, searchtext, id, stamp, result_length1);
}


static XnoiseItem* xnoise_data_source_real_get_albums_with_search (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_albums_with_search'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseItem* xnoise_data_source_get_albums_with_search (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_albums_with_search (self, searchtext, id, stamp, result_length1);
}


static XnoiseTrackData* xnoise_data_source_real_get_trackdata_by_titleid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_trackdata_by_titleid'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseTrackData* xnoise_data_source_get_trackdata_by_titleid (XnoiseDataSource* self, const gchar* searchtext, gint32 id, guint32 stamp) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_trackdata_by_titleid (self, searchtext, id, stamp);
}


static gboolean xnoise_data_source_real_get_stream_td_for_id (XnoiseDataSource* self, gint32 id, XnoiseTrackData** tmp, guint32 stamp) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_stream_td_for_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return FALSE;
}


gboolean xnoise_data_source_get_stream_td_for_id (XnoiseDataSource* self, gint32 id, XnoiseTrackData** tmp, guint32 stamp) {
	g_return_val_if_fail (self != NULL, FALSE);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_stream_td_for_id (self, id, tmp, stamp);
}


static XnoiseTrackData** xnoise_data_source_real_get_all_tracks (XnoiseDataSource* self, const gchar* searchtext, int* result_length1) {
	g_critical ("Type `%s' does not implement abstract method `xnoise_data_source_get_all_tracks'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


XnoiseTrackData** xnoise_data_source_get_all_tracks (XnoiseDataSource* self, const gchar* searchtext, int* result_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return XNOISE_DATA_SOURCE_GET_CLASS (self)->get_all_tracks (self, searchtext, result_length1);
}


XnoiseDataSource* xnoise_data_source_construct (GType object_type) {
	XnoiseDataSource * self = NULL;
	self = (XnoiseDataSource*) g_object_new (object_type, NULL);
	return self;
}


static void xnoise_data_source_class_init (XnoiseDataSourceClass * klass) {
	xnoise_data_source_parent_class = g_type_class_peek_parent (klass);
	XNOISE_DATA_SOURCE_CLASS (klass)->get_datasource_name = xnoise_data_source_real_get_datasource_name;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_for_uri = xnoise_data_source_real_get_trackdata_for_uri;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_artists_with_search = xnoise_data_source_real_get_artists_with_search;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_artistid = xnoise_data_source_real_get_trackdata_by_artistid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_artistitem_by_artistid = xnoise_data_source_real_get_artistitem_by_artistid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_albumid = xnoise_data_source_real_get_trackdata_by_albumid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_albums_with_search = xnoise_data_source_real_get_albums_with_search;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_titleid = xnoise_data_source_real_get_trackdata_by_titleid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_stream_td_for_id = xnoise_data_source_real_get_stream_td_for_id;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_all_tracks = xnoise_data_source_real_get_all_tracks;
	G_OBJECT_CLASS (klass)->finalize = xnoise_data_source_finalize;
	g_signal_new ("refreshed_stamp", XNOISE_TYPE_DATA_SOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__UINT, G_TYPE_NONE, 1, G_TYPE_UINT);
}


static void xnoise_data_source_instance_init (XnoiseDataSource * self) {
}


static void xnoise_data_source_finalize (GObject* obj) {
	XnoiseDataSource * self;
	self = XNOISE_DATA_SOURCE (obj);
	G_OBJECT_CLASS (xnoise_data_source_parent_class)->finalize (obj);
}


GType xnoise_data_source_get_type (void) {
	static volatile gsize xnoise_data_source_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_data_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (XnoiseDataSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_data_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseDataSource), 0, (GInstanceInitFunc) xnoise_data_source_instance_init, NULL };
		GType xnoise_data_source_type_id;
		xnoise_data_source_type_id = g_type_register_static (G_TYPE_OBJECT, "XnoiseDataSource", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&xnoise_data_source_type_id__volatile, xnoise_data_source_type_id);
	}
	return xnoise_data_source_type_id__volatile;
}



