/* xnoise-item.c generated by valac 0.16.0, the Vala compiler
 * generated from xnoise-item.vala, do not modify */

/* xnoise-item.vala
 *
 * Copyright (C) 2011  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define XNOISE_TYPE_ITEM (xnoise_item_get_type ())

#define XNOISE_TYPE_ITEM_TYPE (xnoise_item_type_get_type ())
typedef struct _XnoiseItem XnoiseItem;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	XNOISE_ITEM_TYPE_UNKNOWN = 0,
	XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK,
	XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK,
	XNOISE_ITEM_TYPE_STREAM,
	XNOISE_ITEM_TYPE_CDROM_TRACK,
	XNOISE_ITEM_TYPE_PLAYLIST,
	XNOISE_ITEM_TYPE_LOCAL_FOLDER,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE,
	XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR,
	XNOISE_ITEM_TYPE_LOADER,
	XNOISE_ITEM_TYPE_CUSTOM_DATA_COL_ID,
	XNOISE_ITEM_TYPE_MAXCOUNT
} XnoiseItemType;

struct _XnoiseItem {
	XnoiseItemType type;
	guint32 stamp;
	gint32 db_id;
	gchar* uri;
	gchar* text;
	gint source_id;
};



GType xnoise_item_get_type (void) G_GNUC_CONST;
GType xnoise_item_type_get_type (void) G_GNUC_CONST;
XnoiseItem* xnoise_item_dup (const XnoiseItem* self);
void xnoise_item_free (XnoiseItem* self);
void xnoise_item_copy (const XnoiseItem* self, XnoiseItem* dest);
void xnoise_item_destroy (XnoiseItem* self);
void xnoise_item_init (XnoiseItem *self, XnoiseItemType _type, const gchar* _uri, gint32 _db_id);


void xnoise_item_init (XnoiseItem *self, XnoiseItemType _type, const gchar* _uri, gint32 _db_id) {
	XnoiseItemType _tmp0_;
	gint32 _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	memset (self, 0, sizeof (XnoiseItem));
	_tmp0_ = _type;
	(*self).type = _tmp0_;
	_tmp1_ = _db_id;
	(*self).db_id = _tmp1_;
	_tmp2_ = _uri;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*self).uri);
	(*self).uri = _tmp3_;
}


void xnoise_item_copy (const XnoiseItem* self, XnoiseItem* dest) {
	XnoiseItemType _tmp0_;
	guint32 _tmp1_;
	gint32 _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	_tmp0_ = (*self).type;
	(*dest).type = _tmp0_;
	_tmp1_ = (*self).stamp;
	(*dest).stamp = _tmp1_;
	_tmp2_ = (*self).db_id;
	(*dest).db_id = _tmp2_;
	_tmp3_ = (*self).uri;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 ((*dest).uri);
	(*dest).uri = _tmp4_;
	_tmp5_ = (*self).text;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*dest).text);
	(*dest).text = _tmp6_;
	_tmp7_ = (*self).source_id;
	(*dest).source_id = _tmp7_;
}


void xnoise_item_destroy (XnoiseItem* self) {
	_g_free0 ((*self).uri);
	_g_free0 ((*self).text);
}


XnoiseItem* xnoise_item_dup (const XnoiseItem* self) {
	XnoiseItem* dup;
	dup = g_new0 (XnoiseItem, 1);
	xnoise_item_copy (self, dup);
	return dup;
}


void xnoise_item_free (XnoiseItem* self) {
	xnoise_item_destroy (self);
	g_free (self);
}


GType xnoise_item_get_type (void) {
	static volatile gsize xnoise_item_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_item_type_id__volatile)) {
		GType xnoise_item_type_id;
		xnoise_item_type_id = g_boxed_type_register_static ("XnoiseItem", (GBoxedCopyFunc) xnoise_item_dup, (GBoxedFreeFunc) xnoise_item_free);
		g_once_init_leave (&xnoise_item_type_id__volatile, xnoise_item_type_id);
	}
	return xnoise_item_type_id__volatile;
}


GType xnoise_item_type_get_type (void) {
	static volatile gsize xnoise_item_type_type_id__volatile = 0;
	if (g_once_init_enter (&xnoise_item_type_type_id__volatile)) {
		static const GEnumValue values[] = {{XNOISE_ITEM_TYPE_UNKNOWN, "XNOISE_ITEM_TYPE_UNKNOWN", "unknown"}, {XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK, "XNOISE_ITEM_TYPE_LOCAL_AUDIO_TRACK", "local-audio-track"}, {XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK, "XNOISE_ITEM_TYPE_LOCAL_VIDEO_TRACK", "local-video-track"}, {XNOISE_ITEM_TYPE_STREAM, "XNOISE_ITEM_TYPE_STREAM", "stream"}, {XNOISE_ITEM_TYPE_CDROM_TRACK, "XNOISE_ITEM_TYPE_CDROM_TRACK", "cdrom-track"}, {XNOISE_ITEM_TYPE_PLAYLIST, "XNOISE_ITEM_TYPE_PLAYLIST", "playlist"}, {XNOISE_ITEM_TYPE_LOCAL_FOLDER, "XNOISE_ITEM_TYPE_LOCAL_FOLDER", "local-folder"}, {XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, "XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST", "collection-container-artist"}, {XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM, "XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM", "collection-container-album"}, {XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE, "XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_GENRE", "collection-container-genre"}, {XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR, "XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_YEAR", "collection-container-year"}, {XNOISE_ITEM_TYPE_LOADER, "XNOISE_ITEM_TYPE_LOADER", "loader"}, {XNOISE_ITEM_TYPE_CUSTOM_DATA_COL_ID, "XNOISE_ITEM_TYPE_CUSTOM_DATA_COL_ID", "custom-data-col-id"}, {XNOISE_ITEM_TYPE_MAXCOUNT, "XNOISE_ITEM_TYPE_MAXCOUNT", "maxcount"}, {0, NULL, NULL}};
		GType xnoise_item_type_type_id;
		xnoise_item_type_type_id = g_enum_register_static ("XnoiseItemType", values);
		g_once_init_leave (&xnoise_item_type_type_id__volatile, xnoise_item_type_type_id);
	}
	return xnoise_item_type_type_id__volatile;
}



