/* magnatune-db-reader.c generated by valac 0.16.0, the Vala compiler
 * generated from magnatune-db-reader.vala, do not modify */

/* magnatune-db-reader.vala
 *
 * Copyright (C) 2012  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 *     Jörn Magens
 */

#include <glib.h>
#include <glib-object.h>
#include <xnoise-1.0.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <sqlite3.h>


#define TYPE_MAGNATUNE_DATABASE_READER (magnatune_database_reader_get_type ())
#define MAGNATUNE_DATABASE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReader))
#define MAGNATUNE_DATABASE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReaderClass))
#define IS_MAGNATUNE_DATABASE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAGNATUNE_DATABASE_READER))
#define IS_MAGNATUNE_DATABASE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAGNATUNE_DATABASE_READER))
#define MAGNATUNE_DATABASE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReaderClass))

typedef struct _MagnatuneDatabaseReader MagnatuneDatabaseReader;
typedef struct _MagnatuneDatabaseReaderClass MagnatuneDatabaseReaderClass;
typedef struct _MagnatuneDatabaseReaderPrivate MagnatuneDatabaseReaderPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _xnoise_track_data_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_track_data_unref (var), NULL)))
#define __vala_XnoiseItem_free0(var) ((var == NULL) ? NULL : (var = (_vala_XnoiseItem_free (var), NULL)))

struct _MagnatuneDatabaseReader {
	XnoiseDataSource parent_instance;
	MagnatuneDatabaseReaderPrivate * priv;
};

struct _MagnatuneDatabaseReaderClass {
	XnoiseDataSourceClass parent_class;
};

struct _MagnatuneDatabaseReaderPrivate {
	gchar* DATABASE;
	gchar* _username;
	gchar* _password;
	gchar* http_replacement;
	gboolean _login_data_available;
	GCancellable* cancel;
	gboolean login_data_available_last;
	sqlite3* db;
	sqlite3_stmt* get_artists_with_search_stmt;
	sqlite3_stmt* get_artists_with_search2_stmt;
};


static gpointer magnatune_database_reader_parent_class = NULL;
extern gchar* CONVERTED_DB;
static GType magnatune_database_reader_type_id = 0;

GType magnatune_database_reader_get_type (void) G_GNUC_CONST;
GType magnatune_database_reader_register_type (GTypeModule * module);
#define MAGNATUNE_DATABASE_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MAGNATUNE_DATABASE_READER, MagnatuneDatabaseReaderPrivate))
enum  {
	MAGNATUNE_DATABASE_READER_DUMMY_PROPERTY,
	MAGNATUNE_DATABASE_READER_USERNAME,
	MAGNATUNE_DATABASE_READER_PASSWORD,
	MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE
};
#define MAGNATUNE_DATABASE_READER_data_source_name "MagnatuneDatabase"
#define MAGNATUNE_DATABASE_READER_STMT_TRACKDATA_FOR_URI "SELECT ar.name, al.name, t.title, t.tracknumber, t.length, t.mediatype" \
", t.id, g.name, t.year FROM artists ar, items t, albums al, uris u, ge" \
"nres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = u.id AND" \
" t.genre = g.id AND u.name = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS_WITH_SEARCH "SELECT DISTINCT ar.id, ar.name FROM artists ar, items t, albums al, ge" \
"nres g WHERE t.artist = ar.id AND t.album = al.id AND t.genre = g.id A" \
"ND (utf8_lower(t.title) LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_l" \
"ower(ar.name) LIKE ? OR utf8_lower(g.name) LIKE ?) ORDER BY utf8_lower" \
"(ar.name) COLLATE CUSTOM01 DESC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS "SELECT DISTINCT ar.id, ar.name FROM artists ar, items t WHERE t.artist" \
" = ar.id ORDER BY utf8_lower(ar.name) COLLATE CUSTOM01 DESC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID_WITH_SEARCH "SELECT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar.name, al." \
"name, t.length, g.name, t.year FROM artists ar, items t, albums al, ur" \
"is u, genres g  WHERE t.artist = ar.id AND t.album = al.id AND t.uri =" \
" u.id AND t.genre = g.id AND ar.id = ? AND (utf8_lower(ar.name) LIKE ?" \
" OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ? OR utf8_l" \
"ower(g.name) LIKE ?) GROUP BY utf8_lower(t.title), al.id ORDER BY al.n" \
"ame COLLATE CUSTOM01 ASC, t.tracknumber ASC, t.title COLLATE CUSTOM01 " \
"ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID "SELECT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar.name, al." \
"name, t.length, g.name, t.year  FROM artists ar, items t, albums al, u" \
"ris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri =" \
" u.id AND t.genre = g.id AND ar.id = ? GROUP BY utf8_lower(t.title), a" \
"l.id ORDER BY al.name COLLATE CUSTOM01 ASC, t.tracknumber ASC, t.title" \
" COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID_WITH_SEARCH "SELECT DISTINCT ar.name FROM artists ar, items t, albums al, genres g " \
"WHERE t.artist = ar.id AND t.album = al.id AND t.genre = g.id AND ar.i" \
"d = ? AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(al.name) LIKE ? OR" \
" utf8_lower(t.title) LIKE ? OR utf8_lower(g.name) LIKE ?)"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID "SELECT DISTINCT ar.name FROM artists ar, items t, albums al WHERE t.ar" \
"tist = ar.id AND t.album = al.id AND ar.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_ALBUMID "SELECT DISTINCT al.sku FROM albums al WHERE al.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_TITLEID "SELECT DISTINCT al.sku FROM items t, albums al WHERE t.album = al.id A" \
"ND t.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID_WITH_SEARCH "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND al.id = ? AND (utf8_lower(ar.name" \
") LIKE ? OR utf8_lower(al.name) LIKE ? OR utf8_lower(t.title) LIKE ? O" \
"R utf8_lower(g.name) LIKE ?) GROUP BY utf8_lower(t.title) ORDER BY t.t" \
"racknumber ASC, t.title COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND al.id = ? GROUP BY utf8_lower(t.t" \
"itle) ORDER BY t.tracknumber ASC, t.title COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS_WITH_SEARCH "SELECT DISTINCT al.name, al.id FROM artists ar, albums al, items t, ge" \
"nres g WHERE ar.id = t.artist AND al.id = t.album AND t.genre = g.id A" \
"ND ar.id = ? AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(al.name) LI" \
"KE ? OR utf8_lower(t.title) LIKE ? OR utf8_lower(g.name) LIKE ?) ORDER" \
" BY utf8_lower(al.name) COLLATE CUSTOM01 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS "SELECT DISTINCT al.name, al.id FROM artists ar, albums al WHERE ar.id " \
"= al.artist AND ar.id = ? ORDER BY utf8_lower(al.name) COLLATE CUSTOM0" \
"1 ASC"
#define MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_TITLEID "SELECT DISTINCT t.title, t.mediatype, t.id, t.tracknumber, u.name, ar." \
"name, al.name, t.length, g.name, t.year FROM artists ar, items t, albu" \
"ms al, uris u, genres g WHERE t.artist = ar.id AND t.album = al.id AND" \
" t.uri = u.id AND t.genre = g.id AND t.id = ?"
#define MAGNATUNE_DATABASE_READER_STMT_ALL_TRACKDATA "SELECT ar.name, al.name, t.title, t.tracknumber, t.mediatype, u.name, " \
"t.length, t.id, g.name, t.year FROM artists ar, items t, albums al, ur" \
"is u, genres g WHERE t.artist = ar.id AND t.album = al.id AND t.uri = " \
"u.id AND t.genre = g.id AND (utf8_lower(ar.name) LIKE ? OR utf8_lower(" \
"al.name) LIKE ? OR utf8_lower(t.title) LIKE ?) GROUP BY u.name ORDER B" \
"Y utf8_lower(ar.name) COLLATE CUSTOM01 ASC, utf8_lower(al.name) COLLAT" \
"E CUSTOM01 ASC, t.tracknumber ASC"
static gchar* magnatune_database_reader_transform_mag_url (MagnatuneDatabaseReader* self, const gchar* original_url);
MagnatuneDatabaseReader* magnatune_database_reader_new (GCancellable* cancel);
MagnatuneDatabaseReader* magnatune_database_reader_construct (GType object_type, GCancellable* cancel);
static gchar* magnatune_database_reader_dbFileName (MagnatuneDatabaseReader* self);
static void magnatune_database_reader_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values);
static void _magnatune_database_reader_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values);
static gint magnatune_database_reader_compare_func (gint alen, void* a, gint blen, void* b);
static gint _magnatune_database_reader_compare_func_sqlite_compare_callback (gpointer self, gint alen, void* a, gint blen, void* b);
void magnatune_database_reader_set_username (MagnatuneDatabaseReader* self, const gchar* value);
void magnatune_database_reader_set_password (MagnatuneDatabaseReader* self, const gchar* value);
static void __lambda2_ (MagnatuneDatabaseReader* self);
gboolean magnatune_database_reader_get_login_data_available (MagnatuneDatabaseReader* self);
static void ___lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void magnatune_database_reader_db_error (MagnatuneDatabaseReader* self);
static const gchar* magnatune_database_reader_real_get_datasource_name (XnoiseDataSource* base);
static gboolean magnatune_database_reader_real_get_trackdata_for_uri (XnoiseDataSource* base, gchar** uri, XnoiseTrackData** val);
static XnoiseItem* _xnoise_item_dup (XnoiseItem* self);
static void _vala_XnoiseItem_free (XnoiseItem* self);
static XnoiseItem* magnatune_database_reader_real_get_artists_with_search (XnoiseDataSource* base, const gchar* searchtext, int* result_length1);
static void _vala_XnoiseItem_array_free (XnoiseItem* array, gint array_length);
static void _vala_array_add3 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static void _vala_array_add4 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
static void _vala_array_add5 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
static XnoiseItem* magnatune_database_reader_real_get_artistitem_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp);
gchar* magnatune_database_reader_get_sku_for_album (MagnatuneDatabaseReader* self, gint32 id);
gchar* magnatune_database_reader_get_sku_for_title (MagnatuneDatabaseReader* self, gint32 id);
static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_albumid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
static void _vala_array_add6 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
static XnoiseItem* magnatune_database_reader_real_get_albums_with_search (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1);
static void _vala_array_add7 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value);
static XnoiseTrackData* magnatune_database_reader_real_get_trackdata_by_titleid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp);
static gboolean magnatune_database_reader_real_get_stream_td_for_id (XnoiseDataSource* base, gint32 id, XnoiseTrackData** val, guint32 stamp);
static XnoiseTrackData** magnatune_database_reader_real_get_all_tracks (XnoiseDataSource* base, const gchar* searchtext, int* result_length1);
static void _vala_array_add8 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value);
const gchar* magnatune_database_reader_get_username (MagnatuneDatabaseReader* self);
void magnatune_database_reader_set_login_data_available (MagnatuneDatabaseReader* self, gboolean value);
const gchar* magnatune_database_reader_get_password (MagnatuneDatabaseReader* self);
static void magnatune_database_reader_finalize (GObject* obj);
static void _vala_magnatune_database_reader_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_magnatune_database_reader_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch25_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp5_ = regex;
		_tmp6_ = replacement;
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch25_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp8_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally25;
	__catch25_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally25:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _result_;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static gchar* magnatune_database_reader_transform_mag_url (MagnatuneDatabaseReader* self, const gchar* original_url) {
	gchar* result = NULL;
	gboolean _tmp0_;
	const gchar* _tmp3_;
	gchar* url = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* suff = NULL;
	gint inx = 0;
	const gchar* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (original_url != NULL, NULL);
	_tmp0_ = self->priv->_login_data_available;
	if (!_tmp0_) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = original_url;
		_tmp2_ = g_strdup (_tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = original_url;
	if (_tmp3_ == NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
		result = _tmp4_;
		return result;
	}
	_tmp5_ = original_url;
	_tmp6_ = self->priv->http_replacement;
	_tmp7_ = string_replace (_tmp5_, "http://he3.magnatune.com", _tmp6_);
	_g_free0 (url);
	url = _tmp7_;
	_tmp8_ = url;
	_tmp9_ = string_last_index_of (_tmp8_, ".", 0);
	inx = _tmp9_;
	_tmp10_ = inx;
	if (_tmp10_ != (-1)) {
		const gchar* _tmp11_;
		gint _tmp12_;
		const gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gchar* _tmp17_ = NULL;
		const gchar* _tmp18_;
		gint _tmp19_;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp11_ = url;
		_tmp12_ = inx;
		_tmp13_ = url;
		_tmp14_ = strlen (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = inx;
		_tmp17_ = string_substring (_tmp11_, (glong) (_tmp12_ + 1), (glong) ((_tmp15_ - _tmp16_) - 1));
		_g_free0 (suff);
		suff = _tmp17_;
		_tmp18_ = url;
		_tmp19_ = inx;
		_tmp20_ = string_substring (_tmp18_, (glong) 0, (glong) _tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp21_, "_nospeech.", NULL);
		_tmp23_ = _tmp22_;
		_tmp24_ = suff;
		_tmp25_ = g_strconcat (_tmp23_, _tmp24_, NULL);
		_tmp26_ = _tmp25_;
		_g_free0 (_tmp23_);
		_g_free0 (_tmp21_);
		result = _tmp26_;
		_g_free0 (suff);
		_g_free0 (url);
		return result;
	} else {
		result = url;
		_g_free0 (suff);
		return result;
	}
	_g_free0 (suff);
	_g_free0 (url);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _magnatune_database_reader_utf8_lower_sqlite_user_func_callback (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	magnatune_database_reader_utf8_lower (context, values_length1, values);
}


static gint _magnatune_database_reader_compare_func_sqlite_compare_callback (gpointer self, gint alen, void* a, gint blen, void* b) {
	gint result;
	result = magnatune_database_reader_compare_func (alen, a, blen, b);
	return result;
}


static void __lambda2_ (MagnatuneDatabaseReader* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp3_;
	gboolean _tmp7_;
	_tmp1_ = self->priv->_login_data_available;
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = self->priv->login_data_available_last;
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		const gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		guint32 _tmp6_ = 0U;
		_tmp4_ = xnoise_data_source_get_datasource_name ((XnoiseDataSource*) self);
		xnoise_renew_stamp (_tmp4_);
		_tmp5_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		_tmp6_ = xnoise_get_current_stamp (_tmp5_);
		g_signal_emit_by_name ((XnoiseDataSource*) self, "refreshed-stamp", _tmp6_);
	}
	_tmp7_ = self->priv->_login_data_available;
	self->priv->login_data_available_last = _tmp7_;
}


static void ___lambda2__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda2_ (self);
}


MagnatuneDatabaseReader* magnatune_database_reader_construct (GType object_type, GCancellable* cancel) {
	MagnatuneDatabaseReader * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	sqlite3* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	sqlite3* _tmp7_;
	sqlite3* _tmp8_;
	sqlite3* _tmp9_;
	sqlite3* _tmp10_;
	sqlite3_stmt* _tmp11_ = NULL;
	sqlite3* _tmp12_;
	sqlite3_stmt* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	g_return_val_if_fail (cancel != NULL, NULL);
	self = (MagnatuneDatabaseReader*) xnoise_data_source_construct (object_type);
	_tmp0_ = cancel;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->cancel);
	self->priv->cancel = _tmp1_;
	_tmp2_ = magnatune_database_reader_dbFileName (self);
	_g_free0 (self->priv->DATABASE);
	self->priv->DATABASE = _tmp2_;
	_sqlite3_close0 (self->priv->db);
	self->priv->db = NULL;
	_tmp3_ = self->priv->DATABASE;
	_tmp5_ = sqlite3_open_v2 (_tmp3_, &_tmp4_, SQLITE_OPEN_READONLY, NULL);
	_sqlite3_close0 (self->priv->db);
	self->priv->db = _tmp4_;
	if (_tmp5_ != SQLITE_OK) {
		sqlite3* _tmp6_;
		_tmp6_ = self->priv->db;
		g_error ("magnatune-db-reader.vala:109: Can't open magnatune database: %s\n", (const gchar*) sqlite3_errmsg);
	}
	_tmp7_ = self->priv->db;
	if (_tmp7_ == NULL) {
		g_error ("magnatune-db-reader.vala:112: magnatune db failed");
	}
	_tmp8_ = self->priv->db;
	sqlite3_create_function_v2 (_tmp8_, "utf8_lower", 1, SQLITE_ANY, NULL, _magnatune_database_reader_utf8_lower_sqlite_user_func_callback, NULL, NULL, NULL);
	_tmp9_ = self->priv->db;
	sqlite3_create_collation (_tmp9_, "CUSTOM01", SQLITE_UTF8, NULL, (int (*)(void *, int,  const void *, int,  const void *)) _magnatune_database_reader_compare_func_sqlite_compare_callback);
	_tmp10_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp10_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS_WITH_SEARCH, -1, &_tmp11_, NULL);
	_sqlite3_finalize0 (self->priv->get_artists_with_search_stmt);
	self->priv->get_artists_with_search_stmt = _tmp11_;
	_tmp12_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp12_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTS, -1, &_tmp13_, NULL);
	_sqlite3_finalize0 (self->priv->get_artists_with_search2_stmt);
	self->priv->get_artists_with_search2_stmt = _tmp13_;
	_tmp14_ = xnoise_params_get_string_value ("magnatune_user");
	_tmp15_ = _tmp14_;
	magnatune_database_reader_set_username (self, _tmp15_);
	_g_free0 (_tmp15_);
	_tmp16_ = xnoise_params_get_string_value ("magnatune_pass");
	_tmp17_ = _tmp16_;
	magnatune_database_reader_set_password (self, _tmp17_);
	_g_free0 (_tmp17_);
	g_signal_connect_object ((GObject*) self, "notify::login-data-available", (GCallback) ___lambda2__g_object_notify, self, 0);
	return self;
}


MagnatuneDatabaseReader* magnatune_database_reader_new (GCancellable* cancel) {
	return magnatune_database_reader_construct (TYPE_MAGNATUNE_DATABASE_READER, cancel);
}


static void magnatune_database_reader_utf8_lower (sqlite3_context* context, int values_length1, sqlite3_value** values) {
	sqlite3_context* _tmp0_;
	sqlite3_value** _tmp1_;
	gint _tmp1__length1;
	sqlite3_value* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GDestroyNotify _tmp5_;
	g_return_if_fail (context != NULL);
	_tmp0_ = context;
	_tmp1_ = values;
	_tmp1__length1 = values_length1;
	_tmp2_ = _tmp1_[0];
	_tmp3_ = sqlite3_value_text (_tmp2_);
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) (-1));
	_tmp5_ = g_free;
	sqlite3_result_text (_tmp0_, _tmp4_, -1, _tmp5_);
}


static gint magnatune_database_reader_compare_func (gint alen, void* a, gint blen, void* b) {
	gint result = 0;
	GCompareFunc _tmp0_;
	void* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	void* _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	_tmp0_ = g_strcmp0;
	_tmp1_ = a;
	_tmp2_ = alen;
	_tmp3_ = g_utf8_collate_key ((const gchar*) _tmp1_, (gssize) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = b;
	_tmp6_ = blen;
	_tmp7_ = g_utf8_collate_key ((const gchar*) _tmp5_, (gssize) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _tmp0_ (_tmp4_, _tmp8_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	_g_free0 (_tmp4_);
	result = _tmp10_;
	return result;
}


static gchar* magnatune_database_reader_dbFileName (MagnatuneDatabaseReader* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = CONVERTED_DB;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


static void magnatune_database_reader_db_error (MagnatuneDatabaseReader* self) {
	sqlite3* _tmp0_;
	gint _tmp1_ = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = sqlite3_errcode (_tmp0_);
	_tmp2_ = self->priv->db;
	_tmp3_ = sqlite3_errmsg (_tmp2_);
	g_print ("Database error %d: %s \n\n", _tmp1_, _tmp3_);
}


static const gchar* magnatune_database_reader_real_get_datasource_name (XnoiseDataSource* base) {
	MagnatuneDatabaseReader * self;
	const gchar* result = NULL;
	self = (MagnatuneDatabaseReader*) base;
	result = MAGNATUNE_DATABASE_READER_data_source_name;
	return result;
}


static XnoiseItem* _xnoise_item_dup (XnoiseItem* self) {
	XnoiseItem* dup;
	dup = g_new0 (XnoiseItem, 1);
	xnoise_item_copy (self, dup);
	return dup;
}


static gpointer __xnoise_item_dup0 (gpointer self) {
	return self ? _xnoise_item_dup (self) : NULL;
}


static void _vala_XnoiseItem_free (XnoiseItem* self) {
	xnoise_item_destroy (self);
	g_free (self);
}


static gboolean magnatune_database_reader_real_get_trackdata_for_uri (XnoiseDataSource* base, gchar** uri, XnoiseTrackData** val) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData* _vala_val = NULL;
	gboolean result = FALSE;
	gboolean retval;
	XnoiseTrackData* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	guint32 _tmp3_ = 0U;
	guint32 stamp;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp4_;
	sqlite3_stmt* _tmp5_ = NULL;
	gboolean found;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDestroyNotify _tmp10_;
	sqlite3_stmt* _tmp11_;
	gint _tmp12_ = 0;
	gboolean _tmp53_;
	XnoiseTrackData* _tmp103_;
	const gchar* _tmp104_;
	XnoiseTrackData* _tmp105_;
	const gchar* _tmp106_;
	XnoiseTrackData* _tmp109_;
	const gchar* _tmp110_;
	XnoiseTrackData* _tmp111_;
	const gchar* _tmp112_;
	XnoiseTrackData* _tmp115_;
	const gchar* _tmp116_;
	XnoiseTrackData* _tmp117_;
	const gchar* _tmp118_;
	XnoiseTrackData* _tmp121_;
	const gchar* _tmp122_;
	XnoiseTrackData* _tmp123_;
	const gchar* _tmp124_;
	self = (MagnatuneDatabaseReader*) base;
	retval = FALSE;
	_tmp0_ = xnoise_track_data_new ();
	_xnoise_track_data_unref0 (_vala_val);
	_vala_val = _tmp0_;
	_tmp1_ = *uri;
	if (_tmp1_ == NULL) {
		result = retval;
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	_tmp2_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp3_ = xnoise_get_current_stamp (_tmp2_);
	stamp = _tmp3_;
	_tmp4_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp4_, MAGNATUNE_DATABASE_READER_STMT_TRACKDATA_FOR_URI, -1, &_tmp5_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp5_;
	found = FALSE;
	_tmp6_ = stmt;
	sqlite3_reset (_tmp6_);
	_tmp7_ = stmt;
	_tmp8_ = *uri;
	_tmp9_ = g_strdup (_tmp8_);
	_tmp10_ = g_free;
	sqlite3_bind_text (_tmp7_, 1, _tmp9_, -1, _tmp10_);
	_tmp11_ = stmt;
	_tmp12_ = sqlite3_step (_tmp11_);
	if (_tmp12_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp13_;
		sqlite3_stmt* _tmp14_;
		const gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		XnoiseTrackData* _tmp17_;
		sqlite3_stmt* _tmp18_;
		const gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		XnoiseTrackData* _tmp21_;
		sqlite3_stmt* _tmp22_;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		XnoiseTrackData* _tmp25_;
		sqlite3_stmt* _tmp26_;
		gint _tmp27_ = 0;
		XnoiseTrackData* _tmp28_;
		sqlite3_stmt* _tmp29_;
		gint _tmp30_ = 0;
		XnoiseTrackData* _tmp31_;
		sqlite3_stmt* _tmp32_;
		gint _tmp33_ = 0;
		const gchar* _tmp34_;
		sqlite3_stmt* _tmp35_;
		gint _tmp36_ = 0;
		XnoiseItem _tmp37_ = {0};
		XnoiseItem _tmp38_;
		XnoiseItem* _tmp39_;
		XnoiseTrackData* _tmp40_;
		XnoiseItem* _tmp41_;
		gint _tmp42_ = 0;
		XnoiseTrackData* _tmp43_;
		XnoiseItem* _tmp44_;
		guint32 _tmp45_;
		XnoiseTrackData* _tmp46_;
		sqlite3_stmt* _tmp47_;
		const gchar* _tmp48_ = NULL;
		gchar* _tmp49_;
		XnoiseTrackData* _tmp50_;
		sqlite3_stmt* _tmp51_;
		gint _tmp52_ = 0;
		_tmp13_ = _vala_val;
		_tmp14_ = stmt;
		_tmp15_ = sqlite3_column_text (_tmp14_, 0);
		_tmp16_ = g_strdup (_tmp15_);
		_g_free0 (_tmp13_->artist);
		_tmp13_->artist = _tmp16_;
		_tmp17_ = _vala_val;
		_tmp18_ = stmt;
		_tmp19_ = sqlite3_column_text (_tmp18_, 1);
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp17_->album);
		_tmp17_->album = _tmp20_;
		_tmp21_ = _vala_val;
		_tmp22_ = stmt;
		_tmp23_ = sqlite3_column_text (_tmp22_, 2);
		_tmp24_ = g_strdup (_tmp23_);
		_g_free0 (_tmp21_->title);
		_tmp21_->title = _tmp24_;
		_tmp25_ = _vala_val;
		_tmp26_ = stmt;
		_tmp27_ = sqlite3_column_int (_tmp26_, 3);
		_tmp25_->tracknumber = (guint) _tmp27_;
		_tmp28_ = _vala_val;
		_tmp29_ = stmt;
		_tmp30_ = sqlite3_column_int (_tmp29_, 4);
		_tmp28_->length = (gint32) _tmp30_;
		_tmp31_ = _vala_val;
		_tmp32_ = stmt;
		_tmp33_ = sqlite3_column_int (_tmp32_, 5);
		_tmp34_ = *uri;
		_tmp35_ = stmt;
		_tmp36_ = sqlite3_column_int (_tmp35_, 6);
		xnoise_item_init (&_tmp37_, (XnoiseItemType) _tmp33_, _tmp34_, (gint32) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = __xnoise_item_dup0 (&_tmp38_);
		__vala_XnoiseItem_free0 (_tmp31_->item);
		_tmp31_->item = _tmp39_;
		xnoise_item_destroy (&_tmp38_);
		_tmp40_ = _vala_val;
		_tmp41_ = _tmp40_->item;
		_tmp42_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp41_).source_id = _tmp42_;
		_tmp43_ = _vala_val;
		_tmp44_ = _tmp43_->item;
		_tmp45_ = stamp;
		(*_tmp44_).stamp = _tmp45_;
		_tmp46_ = _vala_val;
		_tmp47_ = stmt;
		_tmp48_ = sqlite3_column_text (_tmp47_, 7);
		_tmp49_ = g_strdup (_tmp48_);
		_g_free0 (_tmp46_->genre);
		_tmp46_->genre = _tmp49_;
		_tmp50_ = _vala_val;
		_tmp51_ = stmt;
		_tmp52_ = sqlite3_column_int (_tmp51_, 8);
		_tmp50_->year = (guint) _tmp52_;
		retval = TRUE;
		found = TRUE;
	}
	_tmp53_ = found;
	if (_tmp53_ == FALSE) {
		sqlite3_stmt* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_ = NULL;
		gchar* turi;
		sqlite3_stmt* _tmp57_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
		GDestroyNotify _tmp60_;
		sqlite3_stmt* _tmp61_;
		gint _tmp62_ = 0;
		_tmp54_ = stmt;
		sqlite3_reset (_tmp54_);
		_tmp55_ = *uri;
		_tmp56_ = magnatune_database_reader_transform_mag_url (self, _tmp55_);
		turi = _tmp56_;
		_tmp57_ = stmt;
		_tmp58_ = turi;
		_tmp59_ = g_strdup (_tmp58_);
		_tmp60_ = g_free;
		sqlite3_bind_text (_tmp57_, 1, _tmp59_, -1, _tmp60_);
		_tmp61_ = stmt;
		_tmp62_ = sqlite3_step (_tmp61_);
		if (_tmp62_ == SQLITE_ROW) {
			XnoiseTrackData* _tmp63_;
			sqlite3_stmt* _tmp64_;
			const gchar* _tmp65_ = NULL;
			gchar* _tmp66_;
			XnoiseTrackData* _tmp67_;
			sqlite3_stmt* _tmp68_;
			const gchar* _tmp69_ = NULL;
			gchar* _tmp70_;
			XnoiseTrackData* _tmp71_;
			sqlite3_stmt* _tmp72_;
			const gchar* _tmp73_ = NULL;
			gchar* _tmp74_;
			XnoiseTrackData* _tmp75_;
			sqlite3_stmt* _tmp76_;
			gint _tmp77_ = 0;
			XnoiseTrackData* _tmp78_;
			sqlite3_stmt* _tmp79_;
			gint _tmp80_ = 0;
			XnoiseTrackData* _tmp81_;
			sqlite3_stmt* _tmp82_;
			gint _tmp83_ = 0;
			const gchar* _tmp84_;
			sqlite3_stmt* _tmp85_;
			gint _tmp86_ = 0;
			XnoiseItem _tmp87_ = {0};
			XnoiseItem _tmp88_;
			XnoiseItem* _tmp89_;
			XnoiseTrackData* _tmp90_;
			XnoiseItem* _tmp91_;
			gint _tmp92_ = 0;
			XnoiseTrackData* _tmp93_;
			XnoiseItem* _tmp94_;
			guint32 _tmp95_;
			XnoiseTrackData* _tmp96_;
			sqlite3_stmt* _tmp97_;
			const gchar* _tmp98_ = NULL;
			gchar* _tmp99_;
			XnoiseTrackData* _tmp100_;
			sqlite3_stmt* _tmp101_;
			gint _tmp102_ = 0;
			_tmp63_ = _vala_val;
			_tmp64_ = stmt;
			_tmp65_ = sqlite3_column_text (_tmp64_, 0);
			_tmp66_ = g_strdup (_tmp65_);
			_g_free0 (_tmp63_->artist);
			_tmp63_->artist = _tmp66_;
			_tmp67_ = _vala_val;
			_tmp68_ = stmt;
			_tmp69_ = sqlite3_column_text (_tmp68_, 1);
			_tmp70_ = g_strdup (_tmp69_);
			_g_free0 (_tmp67_->album);
			_tmp67_->album = _tmp70_;
			_tmp71_ = _vala_val;
			_tmp72_ = stmt;
			_tmp73_ = sqlite3_column_text (_tmp72_, 2);
			_tmp74_ = g_strdup (_tmp73_);
			_g_free0 (_tmp71_->title);
			_tmp71_->title = _tmp74_;
			_tmp75_ = _vala_val;
			_tmp76_ = stmt;
			_tmp77_ = sqlite3_column_int (_tmp76_, 3);
			_tmp75_->tracknumber = (guint) _tmp77_;
			_tmp78_ = _vala_val;
			_tmp79_ = stmt;
			_tmp80_ = sqlite3_column_int (_tmp79_, 4);
			_tmp78_->length = (gint32) _tmp80_;
			_tmp81_ = _vala_val;
			_tmp82_ = stmt;
			_tmp83_ = sqlite3_column_int (_tmp82_, 5);
			_tmp84_ = turi;
			_tmp85_ = stmt;
			_tmp86_ = sqlite3_column_int (_tmp85_, 6);
			xnoise_item_init (&_tmp87_, (XnoiseItemType) _tmp83_, _tmp84_, (gint32) _tmp86_);
			_tmp88_ = _tmp87_;
			_tmp89_ = __xnoise_item_dup0 (&_tmp88_);
			__vala_XnoiseItem_free0 (_tmp81_->item);
			_tmp81_->item = _tmp89_;
			xnoise_item_destroy (&_tmp88_);
			_tmp90_ = _vala_val;
			_tmp91_ = _tmp90_->item;
			_tmp92_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
			(*_tmp91_).source_id = _tmp92_;
			_tmp93_ = _vala_val;
			_tmp94_ = _tmp93_->item;
			_tmp95_ = stamp;
			(*_tmp94_).stamp = _tmp95_;
			_tmp96_ = _vala_val;
			_tmp97_ = stmt;
			_tmp98_ = sqlite3_column_text (_tmp97_, 7);
			_tmp99_ = g_strdup (_tmp98_);
			_g_free0 (_tmp96_->genre);
			_tmp96_->genre = _tmp99_;
			_tmp100_ = _vala_val;
			_tmp101_ = stmt;
			_tmp102_ = sqlite3_column_int (_tmp101_, 8);
			_tmp100_->year = (guint) _tmp102_;
			retval = TRUE;
		}
		_g_free0 (turi);
	}
	_tmp103_ = _vala_val;
	_tmp104_ = _tmp103_->artist;
	_tmp105_ = _vala_val;
	_tmp106_ = _tmp105_->artist;
	if ((g_strcmp0 (_tmp104_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp106_ == NULL)) {
		XnoiseTrackData* _tmp107_;
		gchar* _tmp108_;
		_tmp107_ = _vala_val;
		_tmp108_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ARTIST);
		_g_free0 (_tmp107_->artist);
		_tmp107_->artist = _tmp108_;
	}
	_tmp109_ = _vala_val;
	_tmp110_ = _tmp109_->album;
	_tmp111_ = _vala_val;
	_tmp112_ = _tmp111_->album;
	if ((g_strcmp0 (_tmp110_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp112_ == NULL)) {
		XnoiseTrackData* _tmp113_;
		gchar* _tmp114_;
		_tmp113_ = _vala_val;
		_tmp114_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ALBUM);
		_g_free0 (_tmp113_->album);
		_tmp113_->album = _tmp114_;
	}
	_tmp115_ = _vala_val;
	_tmp116_ = _tmp115_->genre;
	_tmp117_ = _vala_val;
	_tmp118_ = _tmp117_->genre;
	if ((g_strcmp0 (_tmp116_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp118_ == NULL)) {
		XnoiseTrackData* _tmp119_;
		gchar* _tmp120_;
		_tmp119_ = _vala_val;
		_tmp120_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_GENRE);
		_g_free0 (_tmp119_->genre);
		_tmp119_->genre = _tmp120_;
	}
	_tmp121_ = _vala_val;
	_tmp122_ = _tmp121_->title;
	_tmp123_ = _vala_val;
	_tmp124_ = _tmp123_->title;
	if ((g_strcmp0 (_tmp122_, XNOISE_RESOURCES_EMPTYSTRING) == 0) | (_tmp124_ == NULL)) {
		XnoiseTrackData* _tmp125_;
		gchar* _tmp126_;
		const gchar* _tmp127_;
		GFile* _tmp128_ = NULL;
		GFile* file;
		GFile* _tmp129_;
		gchar* _tmp130_ = NULL;
		gchar* fpath;
		gchar* _tmp131_;
		gchar* fileBasename;
		const gchar* _tmp132_;
		XnoiseTrackData* _tmp135_;
		const gchar* _tmp136_;
		gchar* _tmp137_;
		_tmp125_ = _vala_val;
		_tmp126_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_TITLE);
		_g_free0 (_tmp125_->title);
		_tmp125_->title = _tmp126_;
		_tmp127_ = *uri;
		_tmp128_ = g_file_new_for_uri (_tmp127_);
		file = _tmp128_;
		_tmp129_ = file;
		_tmp130_ = g_file_get_path (_tmp129_);
		fpath = _tmp130_;
		_tmp131_ = g_strdup (XNOISE_RESOURCES_EMPTYSTRING);
		fileBasename = _tmp131_;
		_tmp132_ = fpath;
		if (_tmp132_ != NULL) {
			const gchar* _tmp133_;
			gchar* _tmp134_ = NULL;
			_tmp133_ = fpath;
			_tmp134_ = g_filename_display_basename (_tmp133_);
			_g_free0 (fileBasename);
			fileBasename = _tmp134_;
		}
		_tmp135_ = _vala_val;
		_tmp136_ = fileBasename;
		_tmp137_ = g_strdup (_tmp136_);
		_g_free0 (_tmp135_->title);
		_tmp135_->title = _tmp137_;
		_g_free0 (fileBasename);
		_g_free0 (fpath);
		_g_object_unref0 (file);
	}
	result = retval;
	_sqlite3_finalize0 (stmt);
	if (val) {
		*val = _vala_val;
	} else {
		_xnoise_track_data_unref0 (_vala_val);
	}
	return result;
}


static void _vala_XnoiseItem_array_free (XnoiseItem* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			xnoise_item_destroy (&array[i]);
		}
	}
	g_free (array);
}


static void _vala_array_add3 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void _vala_array_add4 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static XnoiseItem* magnatune_database_reader_real_get_artists_with_search (XnoiseDataSource* base, const gchar* searchtext, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseItem* result = NULL;
	XnoiseItem* _tmp0_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	GCancellable* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gint _tmp4_ = 0;
	guint32 _tmp5_ = 0U;
	guint32 stamp;
	const gchar* _tmp6_;
	XnoiseItem* _tmp69_;
	gint _tmp69__length1;
	XnoiseItem* _tmp70_;
	gint _tmp70__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseItem, 0);
	val = _tmp0_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp1_ = self->priv->cancel;
	_tmp2_ = g_cancellable_is_cancelled (_tmp1_);
	if (_tmp2_) {
		XnoiseItem* _tmp3_;
		gint _tmp3__length1;
		_tmp3_ = val;
		_tmp3__length1 = val_length1;
		if (result_length1) {
			*result_length1 = _tmp3__length1;
		}
		result = _tmp3_;
		return result;
	}
	_tmp4_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp5_ = xnoise_get_current_stamp (_tmp4_);
	stamp = _tmp5_;
	_tmp6_ = searchtext;
	if (g_strcmp0 (_tmp6_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* st;
		sqlite3_stmt* _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		sqlite3_stmt* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GDestroyNotify _tmp16_;
		gint _tmp17_ = 0;
		gboolean _tmp23_;
		gboolean _tmp29_;
		gboolean _tmp35_;
		_tmp7_ = searchtext;
		_tmp8_ = g_strdup_printf ("%%%s%%", _tmp7_);
		st = _tmp8_;
		_tmp9_ = self->priv->get_artists_with_search_stmt;
		sqlite3_reset (_tmp9_);
		_tmp13_ = self->priv->get_artists_with_search_stmt;
		_tmp14_ = st;
		_tmp15_ = g_strdup (_tmp14_);
		_tmp16_ = g_free;
		_tmp17_ = sqlite3_bind_text (_tmp13_, 1, _tmp15_, -1, _tmp16_);
		if (_tmp17_ != SQLITE_OK) {
			_tmp12_ = TRUE;
		} else {
			sqlite3_stmt* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			GDestroyNotify _tmp21_;
			gint _tmp22_ = 0;
			_tmp18_ = self->priv->get_artists_with_search_stmt;
			_tmp19_ = st;
			_tmp20_ = g_strdup (_tmp19_);
			_tmp21_ = g_free;
			_tmp22_ = sqlite3_bind_text (_tmp18_, 2, _tmp20_, -1, _tmp21_);
			_tmp12_ = _tmp22_ != SQLITE_OK;
		}
		_tmp23_ = _tmp12_;
		if (_tmp23_) {
			_tmp11_ = TRUE;
		} else {
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			GDestroyNotify _tmp27_;
			gint _tmp28_ = 0;
			_tmp24_ = self->priv->get_artists_with_search_stmt;
			_tmp25_ = st;
			_tmp26_ = g_strdup (_tmp25_);
			_tmp27_ = g_free;
			_tmp28_ = sqlite3_bind_text (_tmp24_, 3, _tmp26_, -1, _tmp27_);
			_tmp11_ = _tmp28_ != SQLITE_OK;
		}
		_tmp29_ = _tmp11_;
		if (_tmp29_) {
			_tmp10_ = TRUE;
		} else {
			sqlite3_stmt* _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
			GDestroyNotify _tmp33_;
			gint _tmp34_ = 0;
			_tmp30_ = self->priv->get_artists_with_search_stmt;
			_tmp31_ = st;
			_tmp32_ = g_strdup (_tmp31_);
			_tmp33_ = g_free;
			_tmp34_ = sqlite3_bind_text (_tmp30_, 4, _tmp32_, -1, _tmp33_);
			_tmp10_ = _tmp34_ != SQLITE_OK;
		}
		_tmp35_ = _tmp10_;
		if (_tmp35_) {
			XnoiseItem* _tmp36_;
			gint _tmp36__length1;
			XnoiseItem* _tmp37_;
			gint _tmp37__length1;
			magnatune_database_reader_db_error (self);
			_tmp36_ = val;
			_tmp36__length1 = val_length1;
			val = NULL;
			_tmp37_ = _tmp36_;
			_tmp37__length1 = _tmp36__length1;
			if (result_length1) {
				*result_length1 = _tmp37__length1;
			}
			result = _tmp37_;
			_g_free0 (st);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		while (TRUE) {
			sqlite3_stmt* _tmp38_;
			gint _tmp39_ = 0;
			GCancellable* _tmp40_;
			gboolean _tmp41_ = FALSE;
			sqlite3_stmt* _tmp43_;
			gint _tmp44_ = 0;
			XnoiseItem i = {0};
			sqlite3_stmt* _tmp45_;
			const gchar* _tmp46_ = NULL;
			gchar* _tmp47_;
			gint _tmp48_ = 0;
			guint32 _tmp49_;
			XnoiseItem* _tmp50_;
			gint _tmp50__length1;
			XnoiseItem _tmp51_;
			XnoiseItem _tmp52_ = {0};
			_tmp38_ = self->priv->get_artists_with_search_stmt;
			_tmp39_ = sqlite3_step (_tmp38_);
			if (!(_tmp39_ == SQLITE_ROW)) {
				break;
			}
			_tmp40_ = self->priv->cancel;
			_tmp41_ = g_cancellable_is_cancelled (_tmp40_);
			if (_tmp41_) {
				XnoiseItem* _tmp42_;
				gint _tmp42__length1;
				_tmp42_ = val;
				_tmp42__length1 = val_length1;
				if (result_length1) {
					*result_length1 = _tmp42__length1;
				}
				result = _tmp42_;
				_g_free0 (st);
				return result;
			}
			_tmp43_ = self->priv->get_artists_with_search_stmt;
			_tmp44_ = sqlite3_column_int (_tmp43_, 0);
			xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, (gint32) _tmp44_);
			_tmp45_ = self->priv->get_artists_with_search_stmt;
			_tmp46_ = sqlite3_column_text (_tmp45_, 1);
			_tmp47_ = g_strdup (_tmp46_);
			_g_free0 (i.text);
			i.text = _tmp47_;
			_tmp48_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
			i.source_id = _tmp48_;
			_tmp49_ = stamp;
			i.stamp = _tmp49_;
			_tmp50_ = val;
			_tmp50__length1 = val_length1;
			_tmp51_ = i;
			xnoise_item_copy (&_tmp51_, &_tmp52_);
			_vala_array_add3 (&val, &val_length1, &_val_size_, &_tmp52_);
			xnoise_item_destroy (&i);
		}
		_g_free0 (st);
	} else {
		sqlite3_stmt* _tmp53_;
		_tmp53_ = self->priv->get_artists_with_search2_stmt;
		sqlite3_reset (_tmp53_);
		while (TRUE) {
			sqlite3_stmt* _tmp54_;
			gint _tmp55_ = 0;
			GCancellable* _tmp56_;
			gboolean _tmp57_ = FALSE;
			sqlite3_stmt* _tmp59_;
			gint _tmp60_ = 0;
			XnoiseItem i = {0};
			sqlite3_stmt* _tmp61_;
			const gchar* _tmp62_ = NULL;
			gchar* _tmp63_;
			gint _tmp64_ = 0;
			guint32 _tmp65_;
			XnoiseItem* _tmp66_;
			gint _tmp66__length1;
			XnoiseItem _tmp67_;
			XnoiseItem _tmp68_ = {0};
			_tmp54_ = self->priv->get_artists_with_search2_stmt;
			_tmp55_ = sqlite3_step (_tmp54_);
			if (!(_tmp55_ == SQLITE_ROW)) {
				break;
			}
			_tmp56_ = self->priv->cancel;
			_tmp57_ = g_cancellable_is_cancelled (_tmp56_);
			if (_tmp57_) {
				XnoiseItem* _tmp58_;
				gint _tmp58__length1;
				_tmp58_ = val;
				_tmp58__length1 = val_length1;
				if (result_length1) {
					*result_length1 = _tmp58__length1;
				}
				result = _tmp58_;
				return result;
			}
			_tmp59_ = self->priv->get_artists_with_search2_stmt;
			_tmp60_ = sqlite3_column_int (_tmp59_, 0);
			xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, (gint32) _tmp60_);
			_tmp61_ = self->priv->get_artists_with_search2_stmt;
			_tmp62_ = sqlite3_column_text (_tmp61_, 1);
			_tmp63_ = g_strdup (_tmp62_);
			_g_free0 (i.text);
			i.text = _tmp63_;
			_tmp64_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
			i.source_id = _tmp64_;
			_tmp65_ = stamp;
			i.stamp = _tmp65_;
			_tmp66_ = val;
			_tmp66__length1 = val_length1;
			_tmp67_ = i;
			xnoise_item_copy (&_tmp67_, &_tmp68_);
			_vala_array_add4 (&val, &val_length1, &_val_size_, &_tmp68_);
			xnoise_item_destroy (&i);
		}
	}
	_tmp69_ = val;
	_tmp69__length1 = val_length1;
	val = NULL;
	_tmp70_ = _tmp69_;
	_tmp70__length1 = _tmp69__length1;
	if (result_length1) {
		*result_length1 = _tmp70__length1;
	}
	result = _tmp70_;
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static gpointer _xnoise_track_data_ref0 (gpointer self) {
	return self ? xnoise_track_data_ref (self) : NULL;
}


static void _vala_array_add5 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData** result = NULL;
	gint _tmp0_ = 0;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_;
	XnoiseTrackData** _tmp3_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp4_;
	XnoiseTrackData** _tmp98_;
	gint _tmp98__length1;
	XnoiseTrackData** _tmp99_;
	gint _tmp99__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp1_ = xnoise_get_current_stamp (_tmp0_);
	_tmp2_ = stamp;
	g_return_val_if_fail (_tmp1_ == _tmp2_, NULL);
	_tmp3_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp3_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp4_ = searchtext;
	if (g_strcmp0 (_tmp4_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* st;
		sqlite3* _tmp7_;
		sqlite3_stmt* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		sqlite3_stmt* _tmp13_;
		gint32 _tmp14_;
		gint _tmp15_ = 0;
		gboolean _tmp21_;
		gboolean _tmp27_;
		gboolean _tmp33_;
		gboolean _tmp39_;
		_tmp5_ = searchtext;
		_tmp6_ = g_strdup_printf ("%%%s%%", _tmp5_);
		st = _tmp6_;
		_tmp7_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp7_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID_WITH_SEARCH, -1, &_tmp8_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp8_;
		_tmp13_ = stmt;
		_tmp14_ = id;
		_tmp15_ = sqlite3_bind_int (_tmp13_, 1, (gint) _tmp14_);
		if (_tmp15_ != SQLITE_OK) {
			_tmp12_ = TRUE;
		} else {
			sqlite3_stmt* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			GDestroyNotify _tmp19_;
			gint _tmp20_ = 0;
			_tmp16_ = stmt;
			_tmp17_ = st;
			_tmp18_ = g_strdup (_tmp17_);
			_tmp19_ = g_free;
			_tmp20_ = sqlite3_bind_text (_tmp16_, 2, _tmp18_, -1, _tmp19_);
			_tmp12_ = _tmp20_ != SQLITE_OK;
		}
		_tmp21_ = _tmp12_;
		if (_tmp21_) {
			_tmp11_ = TRUE;
		} else {
			sqlite3_stmt* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			GDestroyNotify _tmp25_;
			gint _tmp26_ = 0;
			_tmp22_ = stmt;
			_tmp23_ = st;
			_tmp24_ = g_strdup (_tmp23_);
			_tmp25_ = g_free;
			_tmp26_ = sqlite3_bind_text (_tmp22_, 3, _tmp24_, -1, _tmp25_);
			_tmp11_ = _tmp26_ != SQLITE_OK;
		}
		_tmp27_ = _tmp11_;
		if (_tmp27_) {
			_tmp10_ = TRUE;
		} else {
			sqlite3_stmt* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			GDestroyNotify _tmp31_;
			gint _tmp32_ = 0;
			_tmp28_ = stmt;
			_tmp29_ = st;
			_tmp30_ = g_strdup (_tmp29_);
			_tmp31_ = g_free;
			_tmp32_ = sqlite3_bind_text (_tmp28_, 4, _tmp30_, -1, _tmp31_);
			_tmp10_ = _tmp32_ != SQLITE_OK;
		}
		_tmp33_ = _tmp10_;
		if (_tmp33_) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			GDestroyNotify _tmp37_;
			gint _tmp38_ = 0;
			_tmp34_ = stmt;
			_tmp35_ = st;
			_tmp36_ = g_strdup (_tmp35_);
			_tmp37_ = g_free;
			_tmp38_ = sqlite3_bind_text (_tmp34_, 5, _tmp36_, -1, _tmp37_);
			_tmp9_ = _tmp38_ != SQLITE_OK;
		}
		_tmp39_ = _tmp9_;
		if (_tmp39_) {
			XnoiseTrackData** _tmp40_;
			gint _tmp40__length1;
			XnoiseTrackData** _tmp41_;
			gint _tmp41__length1;
			magnatune_database_reader_db_error (self);
			_tmp40_ = val;
			_tmp40__length1 = val_length1;
			val = NULL;
			_tmp41_ = _tmp40_;
			_tmp41__length1 = _tmp40__length1;
			if (result_length1) {
				*result_length1 = _tmp41__length1;
			}
			result = _tmp41_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp42_;
		sqlite3_stmt* _tmp43_ = NULL;
		sqlite3_stmt* _tmp44_;
		gint32 _tmp45_;
		gint _tmp46_ = 0;
		_tmp42_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp42_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ARTISTID, -1, &_tmp43_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp43_;
		_tmp44_ = stmt;
		_tmp45_ = id;
		_tmp46_ = sqlite3_bind_int (_tmp44_, 1, (gint) _tmp45_);
		if (_tmp46_ != SQLITE_OK) {
			XnoiseTrackData** _tmp47_;
			gint _tmp47__length1;
			magnatune_database_reader_db_error (self);
			_tmp47_ = NULL;
			_tmp47__length1 = 0;
			if (result_length1) {
				*result_length1 = _tmp47__length1;
			}
			result = _tmp47_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		XnoiseTrackData* _tmp50_;
		XnoiseTrackData* td;
		sqlite3_stmt* _tmp51_;
		gint _tmp52_ = 0;
		sqlite3_stmt* _tmp53_;
		const gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		gchar* _tmp56_;
		sqlite3_stmt* _tmp57_;
		gint _tmp58_ = 0;
		XnoiseItem _tmp59_ = {0};
		XnoiseItem _tmp60_;
		XnoiseItem* _tmp61_;
		XnoiseItem* _tmp62_;
		XnoiseItem* i;
		XnoiseItem* _tmp63_;
		gint _tmp64_ = 0;
		XnoiseItem* _tmp65_;
		guint32 _tmp66_;
		XnoiseTrackData* _tmp67_;
		sqlite3_stmt* _tmp68_;
		const gchar* _tmp69_ = NULL;
		gchar* _tmp70_;
		XnoiseTrackData* _tmp71_;
		sqlite3_stmt* _tmp72_;
		const gchar* _tmp73_ = NULL;
		gchar* _tmp74_;
		XnoiseTrackData* _tmp75_;
		sqlite3_stmt* _tmp76_;
		const gchar* _tmp77_ = NULL;
		gchar* _tmp78_;
		XnoiseTrackData* _tmp79_;
		XnoiseItem* _tmp80_;
		XnoiseItem* _tmp81_;
		XnoiseTrackData* _tmp82_;
		sqlite3_stmt* _tmp83_;
		gint _tmp84_ = 0;
		XnoiseTrackData* _tmp85_;
		sqlite3_stmt* _tmp86_;
		gint _tmp87_ = 0;
		XnoiseTrackData* _tmp88_;
		sqlite3_stmt* _tmp89_;
		const gchar* _tmp90_ = NULL;
		gchar* _tmp91_;
		XnoiseTrackData* _tmp92_;
		sqlite3_stmt* _tmp93_;
		gint _tmp94_ = 0;
		XnoiseTrackData** _tmp95_;
		gint _tmp95__length1;
		XnoiseTrackData* _tmp96_;
		XnoiseTrackData* _tmp97_;
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_step (_tmp48_);
		if (!(_tmp49_ == SQLITE_ROW)) {
			break;
		}
		_tmp50_ = xnoise_track_data_new ();
		td = _tmp50_;
		_tmp51_ = stmt;
		_tmp52_ = sqlite3_column_int (_tmp51_, 1);
		_tmp53_ = stmt;
		_tmp54_ = sqlite3_column_text (_tmp53_, 4);
		_tmp55_ = magnatune_database_reader_transform_mag_url (self, _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = stmt;
		_tmp58_ = sqlite3_column_int (_tmp57_, 2);
		xnoise_item_init (&_tmp59_, (XnoiseItemType) _tmp52_, _tmp56_, (gint32) _tmp58_);
		_tmp60_ = _tmp59_;
		_tmp61_ = __xnoise_item_dup0 (&_tmp60_);
		_tmp62_ = _tmp61_;
		xnoise_item_destroy (&_tmp60_);
		_g_free0 (_tmp56_);
		i = _tmp62_;
		_tmp63_ = i;
		_tmp64_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp63_).source_id = _tmp64_;
		_tmp65_ = i;
		_tmp66_ = stamp;
		(*_tmp65_).stamp = _tmp66_;
		_tmp67_ = td;
		_tmp68_ = stmt;
		_tmp69_ = sqlite3_column_text (_tmp68_, 5);
		_tmp70_ = g_strdup (_tmp69_);
		_g_free0 (_tmp67_->artist);
		_tmp67_->artist = _tmp70_;
		_tmp71_ = td;
		_tmp72_ = stmt;
		_tmp73_ = sqlite3_column_text (_tmp72_, 6);
		_tmp74_ = g_strdup (_tmp73_);
		_g_free0 (_tmp71_->album);
		_tmp71_->album = _tmp74_;
		_tmp75_ = td;
		_tmp76_ = stmt;
		_tmp77_ = sqlite3_column_text (_tmp76_, 0);
		_tmp78_ = g_strdup (_tmp77_);
		_g_free0 (_tmp75_->title);
		_tmp75_->title = _tmp78_;
		_tmp79_ = td;
		_tmp80_ = i;
		_tmp81_ = __xnoise_item_dup0 (_tmp80_);
		__vala_XnoiseItem_free0 (_tmp79_->item);
		_tmp79_->item = _tmp81_;
		_tmp82_ = td;
		_tmp83_ = stmt;
		_tmp84_ = sqlite3_column_int (_tmp83_, 3);
		_tmp82_->tracknumber = (guint) _tmp84_;
		_tmp85_ = td;
		_tmp86_ = stmt;
		_tmp87_ = sqlite3_column_int (_tmp86_, 7);
		_tmp85_->length = (gint32) _tmp87_;
		_tmp88_ = td;
		_tmp89_ = stmt;
		_tmp90_ = sqlite3_column_text (_tmp89_, 8);
		_tmp91_ = g_strdup (_tmp90_);
		_g_free0 (_tmp88_->genre);
		_tmp88_->genre = _tmp91_;
		_tmp92_ = td;
		_tmp93_ = stmt;
		_tmp94_ = sqlite3_column_int (_tmp93_, 9);
		_tmp92_->year = (guint) _tmp94_;
		_tmp95_ = val;
		_tmp95__length1 = val_length1;
		_tmp96_ = td;
		_tmp97_ = _xnoise_track_data_ref0 (_tmp96_);
		_vala_array_add5 (&val, &val_length1, &_val_size_, _tmp97_);
		__vala_XnoiseItem_free0 (i);
		_xnoise_track_data_unref0 (td);
	}
	_tmp98_ = val;
	_tmp98__length1 = val_length1;
	val = NULL;
	_tmp99_ = _tmp98_;
	_tmp99__length1 = _tmp98__length1;
	if (result_length1) {
		*result_length1 = _tmp99__length1;
	}
	result = _tmp99_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static XnoiseItem* magnatune_database_reader_real_get_artistitem_by_artistid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp) {
	MagnatuneDatabaseReader * self;
	XnoiseItem* result = NULL;
	gint _tmp0_ = 0;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_;
	sqlite3_stmt* stmt = NULL;
	XnoiseItem _tmp3_ = {0};
	XnoiseItem _tmp4_;
	XnoiseItem* _tmp5_;
	XnoiseItem* _tmp6_;
	XnoiseItem* i;
	XnoiseItem* _tmp7_;
	gint _tmp8_ = 0;
	XnoiseItem* _tmp9_;
	guint32 _tmp10_;
	const gchar* _tmp11_;
	sqlite3_stmt* _tmp47_;
	gint _tmp48_ = 0;
	XnoiseItem* _tmp61_;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp1_ = xnoise_get_current_stamp (_tmp0_);
	_tmp2_ = stamp;
	g_return_val_if_fail (_tmp1_ == _tmp2_, NULL);
	xnoise_item_init (&_tmp3_, XNOISE_ITEM_TYPE_UNKNOWN, NULL, (gint32) (-1));
	_tmp4_ = _tmp3_;
	_tmp5_ = __xnoise_item_dup0 (&_tmp4_);
	_tmp6_ = _tmp5_;
	xnoise_item_destroy (&_tmp4_);
	i = _tmp6_;
	_tmp7_ = i;
	_tmp8_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	(*_tmp7_).source_id = _tmp8_;
	_tmp9_ = i;
	_tmp10_ = stamp;
	(*_tmp9_).stamp = _tmp10_;
	_tmp11_ = searchtext;
	if (g_strcmp0 (_tmp11_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* st;
		sqlite3* _tmp14_;
		sqlite3_stmt* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		sqlite3_stmt* _tmp19_;
		gint32 _tmp20_;
		gint _tmp21_ = 0;
		gboolean _tmp27_;
		gboolean _tmp33_;
		gboolean _tmp39_;
		_tmp12_ = searchtext;
		_tmp13_ = g_strdup_printf ("%%%s%%", _tmp12_);
		st = _tmp13_;
		_tmp14_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp14_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID_WITH_SEARCH, -1, &_tmp15_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp15_;
		_tmp19_ = stmt;
		_tmp20_ = id;
		_tmp21_ = sqlite3_bind_int (_tmp19_, 1, (gint) _tmp20_);
		if (_tmp21_ != SQLITE_OK) {
			_tmp18_ = TRUE;
		} else {
			sqlite3_stmt* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			GDestroyNotify _tmp25_;
			gint _tmp26_ = 0;
			_tmp22_ = stmt;
			_tmp23_ = st;
			_tmp24_ = g_strdup (_tmp23_);
			_tmp25_ = g_free;
			_tmp26_ = sqlite3_bind_text (_tmp22_, 2, _tmp24_, -1, _tmp25_);
			_tmp18_ = _tmp26_ != SQLITE_OK;
		}
		_tmp27_ = _tmp18_;
		if (_tmp27_) {
			_tmp17_ = TRUE;
		} else {
			sqlite3_stmt* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			GDestroyNotify _tmp31_;
			gint _tmp32_ = 0;
			_tmp28_ = stmt;
			_tmp29_ = st;
			_tmp30_ = g_strdup (_tmp29_);
			_tmp31_ = g_free;
			_tmp32_ = sqlite3_bind_text (_tmp28_, 3, _tmp30_, -1, _tmp31_);
			_tmp17_ = _tmp32_ != SQLITE_OK;
		}
		_tmp33_ = _tmp17_;
		if (_tmp33_) {
			_tmp16_ = TRUE;
		} else {
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			GDestroyNotify _tmp37_;
			gint _tmp38_ = 0;
			_tmp34_ = stmt;
			_tmp35_ = st;
			_tmp36_ = g_strdup (_tmp35_);
			_tmp37_ = g_free;
			_tmp38_ = sqlite3_bind_text (_tmp34_, 4, _tmp36_, -1, _tmp37_);
			_tmp16_ = _tmp38_ != SQLITE_OK;
		}
		_tmp39_ = _tmp16_;
		if (_tmp39_) {
			XnoiseItem* _tmp40_;
			magnatune_database_reader_db_error (self);
			_tmp40_ = i;
			i = NULL;
			result = _tmp40_;
			_g_free0 (st);
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp41_;
		sqlite3_stmt* _tmp42_ = NULL;
		sqlite3_stmt* _tmp43_;
		gint32 _tmp44_;
		gint _tmp45_ = 0;
		_tmp41_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp41_, MAGNATUNE_DATABASE_READER_STMT_GET_ARTISTITEM_BY_ARTISTID, -1, &_tmp42_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp42_;
		_tmp43_ = stmt;
		_tmp44_ = id;
		_tmp45_ = sqlite3_bind_int (_tmp43_, 1, (gint) _tmp44_);
		if (_tmp45_ != SQLITE_OK) {
			XnoiseItem* _tmp46_;
			magnatune_database_reader_db_error (self);
			_tmp46_ = i;
			i = NULL;
			result = _tmp46_;
			__vala_XnoiseItem_free0 (i);
			_sqlite3_finalize0 (stmt);
			return result;
		}
	}
	_tmp47_ = stmt;
	_tmp48_ = sqlite3_step (_tmp47_);
	if (_tmp48_ == SQLITE_ROW) {
		gint32 _tmp49_;
		XnoiseItem _tmp50_ = {0};
		XnoiseItem _tmp51_;
		XnoiseItem* _tmp52_;
		XnoiseItem* _tmp53_;
		sqlite3_stmt* _tmp54_;
		const gchar* _tmp55_ = NULL;
		gchar* _tmp56_;
		XnoiseItem* _tmp57_;
		gint _tmp58_ = 0;
		XnoiseItem* _tmp59_;
		guint32 _tmp60_;
		_tmp49_ = id;
		xnoise_item_init (&_tmp50_, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ARTIST, NULL, _tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = __xnoise_item_dup0 (&_tmp51_);
		__vala_XnoiseItem_free0 (i);
		i = _tmp52_;
		xnoise_item_destroy (&_tmp51_);
		_tmp53_ = i;
		_tmp54_ = stmt;
		_tmp55_ = sqlite3_column_text (_tmp54_, 0);
		_tmp56_ = g_strdup (_tmp55_);
		_g_free0 ((*_tmp53_).text);
		(*_tmp53_).text = _tmp56_;
		_tmp57_ = i;
		_tmp58_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp57_).source_id = _tmp58_;
		_tmp59_ = i;
		_tmp60_ = stamp;
		(*_tmp59_).stamp = _tmp60_;
	}
	_tmp61_ = i;
	i = NULL;
	result = _tmp61_;
	__vala_XnoiseItem_free0 (i);
	_sqlite3_finalize0 (stmt);
	return result;
}


gchar* magnatune_database_reader_get_sku_for_album (MagnatuneDatabaseReader* self, gint32 id) {
	gchar* result = NULL;
	gchar* val;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint32 _tmp3_;
	gint _tmp4_ = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	g_return_val_if_fail (self != NULL, NULL);
	val = NULL;
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_ALBUMID, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, (gint) _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		magnatune_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	_tmp5_ = stmt;
	_tmp6_ = sqlite3_step (_tmp5_);
	if (_tmp6_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp7_;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp7_ = stmt;
		_tmp8_ = sqlite3_column_text (_tmp7_, 0);
		_tmp9_ = g_strdup (_tmp8_);
		result = _tmp9_;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	result = val;
	_sqlite3_finalize0 (stmt);
	return result;
}


gchar* magnatune_database_reader_get_sku_for_title (MagnatuneDatabaseReader* self, gint32 id) {
	gchar* result = NULL;
	gchar* val;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_;
	gint32 _tmp3_;
	gint _tmp4_ = 0;
	sqlite3_stmt* _tmp5_;
	gint _tmp6_ = 0;
	g_return_val_if_fail (self != NULL, NULL);
	val = NULL;
	_tmp0_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp0_, MAGNATUNE_DATABASE_READER_STMT_GET_SKU_BY_TITLEID, -1, &_tmp1_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp1_;
	_tmp2_ = stmt;
	_tmp3_ = id;
	_tmp4_ = sqlite3_bind_int (_tmp2_, 1, (gint) _tmp3_);
	if (_tmp4_ != SQLITE_OK) {
		magnatune_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	_tmp5_ = stmt;
	_tmp6_ = sqlite3_step (_tmp5_);
	if (_tmp6_ == SQLITE_ROW) {
		sqlite3_stmt* _tmp7_;
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		_tmp7_ = stmt;
		_tmp8_ = sqlite3_column_text (_tmp7_, 0);
		_tmp9_ = g_strdup (_tmp8_);
		result = _tmp9_;
		_sqlite3_finalize0 (stmt);
		_g_free0 (val);
		return result;
	}
	result = val;
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add6 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static XnoiseTrackData** magnatune_database_reader_real_get_trackdata_by_albumid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData** result = NULL;
	gint _tmp0_ = 0;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_;
	XnoiseTrackData** _tmp3_ = NULL;
	XnoiseTrackData** val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp4_;
	XnoiseTrackData** _tmp98_;
	gint _tmp98__length1;
	XnoiseTrackData** _tmp99_;
	gint _tmp99__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp1_ = xnoise_get_current_stamp (_tmp0_);
	_tmp2_ = stamp;
	g_return_val_if_fail (_tmp1_ == _tmp2_, NULL);
	_tmp3_ = g_new0 (XnoiseTrackData*, 0 + 1);
	val = _tmp3_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp4_ = searchtext;
	if (g_strcmp0 (_tmp4_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* st;
		sqlite3* _tmp7_;
		sqlite3_stmt* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		sqlite3_stmt* _tmp13_;
		gint32 _tmp14_;
		gint _tmp15_ = 0;
		gboolean _tmp21_;
		gboolean _tmp27_;
		gboolean _tmp33_;
		gboolean _tmp39_;
		_tmp5_ = searchtext;
		_tmp6_ = g_strdup_printf ("%%%s%%", _tmp5_);
		st = _tmp6_;
		_tmp7_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp7_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID_WITH_SEARCH, -1, &_tmp8_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp8_;
		_tmp13_ = stmt;
		_tmp14_ = id;
		_tmp15_ = sqlite3_bind_int (_tmp13_, 1, (gint) _tmp14_);
		if (_tmp15_ != SQLITE_OK) {
			_tmp12_ = TRUE;
		} else {
			sqlite3_stmt* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			GDestroyNotify _tmp19_;
			gint _tmp20_ = 0;
			_tmp16_ = stmt;
			_tmp17_ = st;
			_tmp18_ = g_strdup (_tmp17_);
			_tmp19_ = g_free;
			_tmp20_ = sqlite3_bind_text (_tmp16_, 2, _tmp18_, -1, _tmp19_);
			_tmp12_ = _tmp20_ != SQLITE_OK;
		}
		_tmp21_ = _tmp12_;
		if (_tmp21_) {
			_tmp11_ = TRUE;
		} else {
			sqlite3_stmt* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			GDestroyNotify _tmp25_;
			gint _tmp26_ = 0;
			_tmp22_ = stmt;
			_tmp23_ = st;
			_tmp24_ = g_strdup (_tmp23_);
			_tmp25_ = g_free;
			_tmp26_ = sqlite3_bind_text (_tmp22_, 3, _tmp24_, -1, _tmp25_);
			_tmp11_ = _tmp26_ != SQLITE_OK;
		}
		_tmp27_ = _tmp11_;
		if (_tmp27_) {
			_tmp10_ = TRUE;
		} else {
			sqlite3_stmt* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			GDestroyNotify _tmp31_;
			gint _tmp32_ = 0;
			_tmp28_ = stmt;
			_tmp29_ = st;
			_tmp30_ = g_strdup (_tmp29_);
			_tmp31_ = g_free;
			_tmp32_ = sqlite3_bind_text (_tmp28_, 4, _tmp30_, -1, _tmp31_);
			_tmp10_ = _tmp32_ != SQLITE_OK;
		}
		_tmp33_ = _tmp10_;
		if (_tmp33_) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			GDestroyNotify _tmp37_;
			gint _tmp38_ = 0;
			_tmp34_ = stmt;
			_tmp35_ = st;
			_tmp36_ = g_strdup (_tmp35_);
			_tmp37_ = g_free;
			_tmp38_ = sqlite3_bind_text (_tmp34_, 5, _tmp36_, -1, _tmp37_);
			_tmp9_ = _tmp38_ != SQLITE_OK;
		}
		_tmp39_ = _tmp9_;
		if (_tmp39_) {
			XnoiseTrackData** _tmp40_;
			gint _tmp40__length1;
			XnoiseTrackData** _tmp41_;
			gint _tmp41__length1;
			magnatune_database_reader_db_error (self);
			_tmp40_ = val;
			_tmp40__length1 = val_length1;
			val = NULL;
			_tmp41_ = _tmp40_;
			_tmp41__length1 = _tmp40__length1;
			if (result_length1) {
				*result_length1 = _tmp41__length1;
			}
			result = _tmp41_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp42_;
		sqlite3_stmt* _tmp43_ = NULL;
		sqlite3_stmt* _tmp44_;
		gint32 _tmp45_;
		gint _tmp46_ = 0;
		_tmp42_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp42_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_ALBUMID, -1, &_tmp43_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp43_;
		_tmp44_ = stmt;
		_tmp45_ = id;
		_tmp46_ = sqlite3_bind_int (_tmp44_, 1, (gint) _tmp45_);
		if (_tmp46_ != SQLITE_OK) {
			XnoiseTrackData** _tmp47_;
			gint _tmp47__length1;
			magnatune_database_reader_db_error (self);
			_tmp47_ = NULL;
			_tmp47__length1 = 0;
			if (result_length1) {
				*result_length1 = _tmp47__length1;
			}
			result = _tmp47_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp48_;
		gint _tmp49_ = 0;
		XnoiseTrackData* _tmp50_;
		XnoiseTrackData* td;
		sqlite3_stmt* _tmp51_;
		gint _tmp52_ = 0;
		sqlite3_stmt* _tmp53_;
		const gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		gchar* _tmp56_;
		sqlite3_stmt* _tmp57_;
		gint _tmp58_ = 0;
		XnoiseItem _tmp59_ = {0};
		XnoiseItem _tmp60_;
		XnoiseItem* _tmp61_;
		XnoiseItem* _tmp62_;
		XnoiseItem* i;
		XnoiseItem* _tmp63_;
		gint _tmp64_ = 0;
		XnoiseItem* _tmp65_;
		guint32 _tmp66_;
		XnoiseTrackData* _tmp67_;
		sqlite3_stmt* _tmp68_;
		const gchar* _tmp69_ = NULL;
		gchar* _tmp70_;
		XnoiseTrackData* _tmp71_;
		sqlite3_stmt* _tmp72_;
		const gchar* _tmp73_ = NULL;
		gchar* _tmp74_;
		XnoiseTrackData* _tmp75_;
		sqlite3_stmt* _tmp76_;
		const gchar* _tmp77_ = NULL;
		gchar* _tmp78_;
		XnoiseTrackData* _tmp79_;
		XnoiseItem* _tmp80_;
		XnoiseItem* _tmp81_;
		XnoiseTrackData* _tmp82_;
		sqlite3_stmt* _tmp83_;
		gint _tmp84_ = 0;
		XnoiseTrackData* _tmp85_;
		sqlite3_stmt* _tmp86_;
		gint _tmp87_ = 0;
		XnoiseTrackData* _tmp88_;
		sqlite3_stmt* _tmp89_;
		const gchar* _tmp90_ = NULL;
		gchar* _tmp91_;
		XnoiseTrackData* _tmp92_;
		sqlite3_stmt* _tmp93_;
		gint _tmp94_ = 0;
		XnoiseTrackData** _tmp95_;
		gint _tmp95__length1;
		XnoiseTrackData* _tmp96_;
		XnoiseTrackData* _tmp97_;
		_tmp48_ = stmt;
		_tmp49_ = sqlite3_step (_tmp48_);
		if (!(_tmp49_ == SQLITE_ROW)) {
			break;
		}
		_tmp50_ = xnoise_track_data_new ();
		td = _tmp50_;
		_tmp51_ = stmt;
		_tmp52_ = sqlite3_column_int (_tmp51_, 1);
		_tmp53_ = stmt;
		_tmp54_ = sqlite3_column_text (_tmp53_, 4);
		_tmp55_ = magnatune_database_reader_transform_mag_url (self, _tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = stmt;
		_tmp58_ = sqlite3_column_int (_tmp57_, 2);
		xnoise_item_init (&_tmp59_, (XnoiseItemType) _tmp52_, _tmp56_, (gint32) _tmp58_);
		_tmp60_ = _tmp59_;
		_tmp61_ = __xnoise_item_dup0 (&_tmp60_);
		_tmp62_ = _tmp61_;
		xnoise_item_destroy (&_tmp60_);
		_g_free0 (_tmp56_);
		i = _tmp62_;
		_tmp63_ = i;
		_tmp64_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp63_).source_id = _tmp64_;
		_tmp65_ = i;
		_tmp66_ = stamp;
		(*_tmp65_).stamp = _tmp66_;
		_tmp67_ = td;
		_tmp68_ = stmt;
		_tmp69_ = sqlite3_column_text (_tmp68_, 5);
		_tmp70_ = g_strdup (_tmp69_);
		_g_free0 (_tmp67_->artist);
		_tmp67_->artist = _tmp70_;
		_tmp71_ = td;
		_tmp72_ = stmt;
		_tmp73_ = sqlite3_column_text (_tmp72_, 6);
		_tmp74_ = g_strdup (_tmp73_);
		_g_free0 (_tmp71_->album);
		_tmp71_->album = _tmp74_;
		_tmp75_ = td;
		_tmp76_ = stmt;
		_tmp77_ = sqlite3_column_text (_tmp76_, 0);
		_tmp78_ = g_strdup (_tmp77_);
		_g_free0 (_tmp75_->title);
		_tmp75_->title = _tmp78_;
		_tmp79_ = td;
		_tmp80_ = i;
		_tmp81_ = __xnoise_item_dup0 (_tmp80_);
		__vala_XnoiseItem_free0 (_tmp79_->item);
		_tmp79_->item = _tmp81_;
		_tmp82_ = td;
		_tmp83_ = stmt;
		_tmp84_ = sqlite3_column_int (_tmp83_, 3);
		_tmp82_->tracknumber = (guint) _tmp84_;
		_tmp85_ = td;
		_tmp86_ = stmt;
		_tmp87_ = sqlite3_column_int (_tmp86_, 7);
		_tmp85_->length = (gint32) _tmp87_;
		_tmp88_ = td;
		_tmp89_ = stmt;
		_tmp90_ = sqlite3_column_text (_tmp89_, 8);
		_tmp91_ = g_strdup (_tmp90_);
		_g_free0 (_tmp88_->genre);
		_tmp88_->genre = _tmp91_;
		_tmp92_ = td;
		_tmp93_ = stmt;
		_tmp94_ = sqlite3_column_int (_tmp93_, 9);
		_tmp92_->year = (guint) _tmp94_;
		_tmp95_ = val;
		_tmp95__length1 = val_length1;
		_tmp96_ = td;
		_tmp97_ = _xnoise_track_data_ref0 (_tmp96_);
		_vala_array_add6 (&val, &val_length1, &_val_size_, _tmp97_);
		__vala_XnoiseItem_free0 (i);
		_xnoise_track_data_unref0 (td);
	}
	_tmp98_ = val;
	_tmp98__length1 = val_length1;
	val = NULL;
	_tmp99_ = _tmp98_;
	_tmp99__length1 = _tmp98__length1;
	if (result_length1) {
		*result_length1 = _tmp99__length1;
	}
	result = _tmp99_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_array_free (val, val_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	return result;
}


static void _vala_array_add7 (XnoiseItem** array, int* length, int* size, const XnoiseItem* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseItem, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static XnoiseItem* magnatune_database_reader_real_get_albums_with_search (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseItem* result = NULL;
	gint _tmp0_ = 0;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_;
	XnoiseItem* _tmp3_ = NULL;
	XnoiseItem* val;
	gint val_length1;
	gint _val_size_;
	sqlite3_stmt* stmt = NULL;
	const gchar* _tmp4_;
	XnoiseItem* _tmp61_;
	gint _tmp61__length1;
	XnoiseItem* _tmp62_;
	gint _tmp62__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp1_ = xnoise_get_current_stamp (_tmp0_);
	_tmp2_ = stamp;
	g_return_val_if_fail (_tmp1_ == _tmp2_, NULL);
	_tmp3_ = g_new0 (XnoiseItem, 0);
	val = _tmp3_;
	val_length1 = 0;
	_val_size_ = val_length1;
	_tmp4_ = searchtext;
	if (g_strcmp0 (_tmp4_, XNOISE_RESOURCES_EMPTYSTRING) != 0) {
		const gchar* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* st;
		sqlite3* _tmp7_;
		sqlite3_stmt* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		sqlite3_stmt* _tmp13_;
		gint32 _tmp14_;
		gint _tmp15_ = 0;
		gboolean _tmp21_;
		gboolean _tmp27_;
		gboolean _tmp33_;
		gboolean _tmp39_;
		_tmp5_ = searchtext;
		_tmp6_ = g_strdup_printf ("%%%s%%", _tmp5_);
		st = _tmp6_;
		_tmp7_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp7_, MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS_WITH_SEARCH, -1, &_tmp8_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp8_;
		_tmp13_ = stmt;
		_tmp14_ = id;
		_tmp15_ = sqlite3_bind_int (_tmp13_, 1, (gint) _tmp14_);
		if (_tmp15_ != SQLITE_OK) {
			_tmp12_ = TRUE;
		} else {
			sqlite3_stmt* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			GDestroyNotify _tmp19_;
			gint _tmp20_ = 0;
			_tmp16_ = stmt;
			_tmp17_ = st;
			_tmp18_ = g_strdup (_tmp17_);
			_tmp19_ = g_free;
			_tmp20_ = sqlite3_bind_text (_tmp16_, 2, _tmp18_, -1, _tmp19_);
			_tmp12_ = _tmp20_ != SQLITE_OK;
		}
		_tmp21_ = _tmp12_;
		if (_tmp21_) {
			_tmp11_ = TRUE;
		} else {
			sqlite3_stmt* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			GDestroyNotify _tmp25_;
			gint _tmp26_ = 0;
			_tmp22_ = stmt;
			_tmp23_ = st;
			_tmp24_ = g_strdup (_tmp23_);
			_tmp25_ = g_free;
			_tmp26_ = sqlite3_bind_text (_tmp22_, 3, _tmp24_, -1, _tmp25_);
			_tmp11_ = _tmp26_ != SQLITE_OK;
		}
		_tmp27_ = _tmp11_;
		if (_tmp27_) {
			_tmp10_ = TRUE;
		} else {
			sqlite3_stmt* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			GDestroyNotify _tmp31_;
			gint _tmp32_ = 0;
			_tmp28_ = stmt;
			_tmp29_ = st;
			_tmp30_ = g_strdup (_tmp29_);
			_tmp31_ = g_free;
			_tmp32_ = sqlite3_bind_text (_tmp28_, 4, _tmp30_, -1, _tmp31_);
			_tmp10_ = _tmp32_ != SQLITE_OK;
		}
		_tmp33_ = _tmp10_;
		if (_tmp33_) {
			_tmp9_ = TRUE;
		} else {
			sqlite3_stmt* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			GDestroyNotify _tmp37_;
			gint _tmp38_ = 0;
			_tmp34_ = stmt;
			_tmp35_ = st;
			_tmp36_ = g_strdup (_tmp35_);
			_tmp37_ = g_free;
			_tmp38_ = sqlite3_bind_text (_tmp34_, 5, _tmp36_, -1, _tmp37_);
			_tmp9_ = _tmp38_ != SQLITE_OK;
		}
		_tmp39_ = _tmp9_;
		if (_tmp39_) {
			XnoiseItem* _tmp40_;
			gint _tmp40__length1;
			XnoiseItem* _tmp41_;
			gint _tmp41__length1;
			magnatune_database_reader_db_error (self);
			_tmp40_ = val;
			_tmp40__length1 = val_length1;
			val = NULL;
			_tmp41_ = _tmp40_;
			_tmp41__length1 = _tmp40__length1;
			if (result_length1) {
				*result_length1 = _tmp41__length1;
			}
			result = _tmp41_;
			_g_free0 (st);
			_sqlite3_finalize0 (stmt);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
		_g_free0 (st);
	} else {
		sqlite3* _tmp42_;
		sqlite3_stmt* _tmp43_ = NULL;
		sqlite3_stmt* _tmp44_;
		gint32 _tmp45_;
		gint _tmp46_ = 0;
		_tmp42_ = self->priv->db;
		sqlite3_prepare_v2 (_tmp42_, MAGNATUNE_DATABASE_READER_STMT_GET_ALBUMS, -1, &_tmp43_, NULL);
		_sqlite3_finalize0 (stmt);
		stmt = _tmp43_;
		_tmp44_ = stmt;
		_tmp45_ = id;
		_tmp46_ = sqlite3_bind_int (_tmp44_, 1, (gint) _tmp45_);
		if (_tmp46_ != SQLITE_OK) {
			XnoiseItem* _tmp47_;
			gint _tmp47__length1;
			XnoiseItem* _tmp48_;
			gint _tmp48__length1;
			magnatune_database_reader_db_error (self);
			_tmp47_ = val;
			_tmp47__length1 = val_length1;
			val = NULL;
			_tmp48_ = _tmp47_;
			_tmp48__length1 = _tmp47__length1;
			if (result_length1) {
				*result_length1 = _tmp48__length1;
			}
			result = _tmp48_;
			_sqlite3_finalize0 (stmt);
			val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
			return result;
		}
	}
	while (TRUE) {
		sqlite3_stmt* _tmp49_;
		gint _tmp50_ = 0;
		sqlite3_stmt* _tmp51_;
		gint _tmp52_ = 0;
		XnoiseItem i = {0};
		sqlite3_stmt* _tmp53_;
		const gchar* _tmp54_ = NULL;
		gchar* _tmp55_;
		gint _tmp56_ = 0;
		guint32 _tmp57_;
		XnoiseItem* _tmp58_;
		gint _tmp58__length1;
		XnoiseItem _tmp59_;
		XnoiseItem _tmp60_ = {0};
		_tmp49_ = stmt;
		_tmp50_ = sqlite3_step (_tmp49_);
		if (!(_tmp50_ == SQLITE_ROW)) {
			break;
		}
		_tmp51_ = stmt;
		_tmp52_ = sqlite3_column_int (_tmp51_, 1);
		xnoise_item_init (&i, XNOISE_ITEM_TYPE_COLLECTION_CONTAINER_ALBUM, NULL, (gint32) _tmp52_);
		_tmp53_ = stmt;
		_tmp54_ = sqlite3_column_text (_tmp53_, 0);
		_tmp55_ = g_strdup (_tmp54_);
		_g_free0 (i.text);
		i.text = _tmp55_;
		_tmp56_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		i.source_id = _tmp56_;
		_tmp57_ = stamp;
		i.stamp = _tmp57_;
		_tmp58_ = val;
		_tmp58__length1 = val_length1;
		_tmp59_ = i;
		xnoise_item_copy (&_tmp59_, &_tmp60_);
		_vala_array_add7 (&val, &val_length1, &_val_size_, &_tmp60_);
		xnoise_item_destroy (&i);
	}
	_tmp61_ = val;
	_tmp61__length1 = val_length1;
	val = NULL;
	_tmp62_ = _tmp61_;
	_tmp62__length1 = _tmp61__length1;
	if (result_length1) {
		*result_length1 = _tmp62__length1;
	}
	result = _tmp62_;
	_sqlite3_finalize0 (stmt);
	val = (_vala_XnoiseItem_array_free (val, val_length1), NULL);
	return result;
}


static XnoiseTrackData* magnatune_database_reader_real_get_trackdata_by_titleid (XnoiseDataSource* base, const gchar* searchtext, gint32 id, guint32 stamp) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData* result = NULL;
	gint _tmp0_ = 0;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	sqlite3_stmt* _tmp5_;
	gint32 _tmp6_;
	gint _tmp7_ = 0;
	XnoiseTrackData* td;
	sqlite3_stmt* _tmp8_;
	gint _tmp9_ = 0;
	XnoiseTrackData* _tmp55_;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp1_ = xnoise_get_current_stamp (_tmp0_);
	_tmp2_ = stamp;
	g_return_val_if_fail (_tmp1_ == _tmp2_, NULL);
	_tmp3_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp3_, MAGNATUNE_DATABASE_READER_STMT_GET_TRACKDATA_BY_TITLEID, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	_tmp5_ = stmt;
	_tmp6_ = id;
	_tmp7_ = sqlite3_bind_int (_tmp5_, 1, (gint) _tmp6_);
	if (_tmp7_ != SQLITE_OK) {
		magnatune_database_reader_db_error (self);
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	td = NULL;
	_tmp8_ = stmt;
	_tmp9_ = sqlite3_step (_tmp8_);
	if (_tmp9_ == SQLITE_ROW) {
		XnoiseTrackData* _tmp10_;
		sqlite3_stmt* _tmp11_;
		gint _tmp12_ = 0;
		sqlite3_stmt* _tmp13_;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		sqlite3_stmt* _tmp17_;
		gint _tmp18_ = 0;
		XnoiseItem _tmp19_ = {0};
		XnoiseItem _tmp20_;
		XnoiseItem* _tmp21_;
		XnoiseItem* _tmp22_;
		XnoiseItem* i;
		XnoiseItem* _tmp23_;
		gint _tmp24_ = 0;
		XnoiseItem* _tmp25_;
		guint32 _tmp26_;
		XnoiseTrackData* _tmp27_;
		sqlite3_stmt* _tmp28_;
		const gchar* _tmp29_ = NULL;
		gchar* _tmp30_;
		XnoiseTrackData* _tmp31_;
		sqlite3_stmt* _tmp32_;
		const gchar* _tmp33_ = NULL;
		gchar* _tmp34_;
		XnoiseTrackData* _tmp35_;
		sqlite3_stmt* _tmp36_;
		const gchar* _tmp37_ = NULL;
		gchar* _tmp38_;
		XnoiseTrackData* _tmp39_;
		XnoiseItem* _tmp40_;
		XnoiseItem* _tmp41_;
		XnoiseTrackData* _tmp42_;
		sqlite3_stmt* _tmp43_;
		gint _tmp44_ = 0;
		XnoiseTrackData* _tmp45_;
		sqlite3_stmt* _tmp46_;
		gint _tmp47_ = 0;
		XnoiseTrackData* _tmp48_;
		sqlite3_stmt* _tmp49_;
		const gchar* _tmp50_ = NULL;
		gchar* _tmp51_;
		XnoiseTrackData* _tmp52_;
		sqlite3_stmt* _tmp53_;
		gint _tmp54_ = 0;
		_tmp10_ = xnoise_track_data_new ();
		_xnoise_track_data_unref0 (td);
		td = _tmp10_;
		_tmp11_ = stmt;
		_tmp12_ = sqlite3_column_int (_tmp11_, 1);
		_tmp13_ = stmt;
		_tmp14_ = sqlite3_column_text (_tmp13_, 4);
		_tmp15_ = magnatune_database_reader_transform_mag_url (self, _tmp14_);
		_tmp16_ = _tmp15_;
		_tmp17_ = stmt;
		_tmp18_ = sqlite3_column_int (_tmp17_, 2);
		xnoise_item_init (&_tmp19_, (XnoiseItemType) _tmp12_, _tmp16_, (gint32) _tmp18_);
		_tmp20_ = _tmp19_;
		_tmp21_ = __xnoise_item_dup0 (&_tmp20_);
		_tmp22_ = _tmp21_;
		xnoise_item_destroy (&_tmp20_);
		_g_free0 (_tmp16_);
		i = _tmp22_;
		_tmp23_ = i;
		_tmp24_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp23_).source_id = _tmp24_;
		_tmp25_ = i;
		_tmp26_ = stamp;
		(*_tmp25_).stamp = _tmp26_;
		_tmp27_ = td;
		_tmp28_ = stmt;
		_tmp29_ = sqlite3_column_text (_tmp28_, 5);
		_tmp30_ = g_strdup (_tmp29_);
		_g_free0 (_tmp27_->artist);
		_tmp27_->artist = _tmp30_;
		_tmp31_ = td;
		_tmp32_ = stmt;
		_tmp33_ = sqlite3_column_text (_tmp32_, 6);
		_tmp34_ = g_strdup (_tmp33_);
		_g_free0 (_tmp31_->album);
		_tmp31_->album = _tmp34_;
		_tmp35_ = td;
		_tmp36_ = stmt;
		_tmp37_ = sqlite3_column_text (_tmp36_, 0);
		_tmp38_ = g_strdup (_tmp37_);
		_g_free0 (_tmp35_->title);
		_tmp35_->title = _tmp38_;
		_tmp39_ = td;
		_tmp40_ = i;
		_tmp41_ = __xnoise_item_dup0 (_tmp40_);
		__vala_XnoiseItem_free0 (_tmp39_->item);
		_tmp39_->item = _tmp41_;
		_tmp42_ = td;
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_int (_tmp43_, 3);
		_tmp42_->tracknumber = (guint) _tmp44_;
		_tmp45_ = td;
		_tmp46_ = stmt;
		_tmp47_ = sqlite3_column_int (_tmp46_, 7);
		_tmp45_->length = (gint32) _tmp47_;
		_tmp48_ = td;
		_tmp49_ = stmt;
		_tmp50_ = sqlite3_column_text (_tmp49_, 8);
		_tmp51_ = g_strdup (_tmp50_);
		_g_free0 (_tmp48_->genre);
		_tmp48_->genre = _tmp51_;
		_tmp52_ = td;
		_tmp53_ = stmt;
		_tmp54_ = sqlite3_column_int (_tmp53_, 9);
		_tmp52_->year = (guint) _tmp54_;
		__vala_XnoiseItem_free0 (i);
	}
	_tmp55_ = td;
	td = NULL;
	result = _tmp55_;
	_xnoise_track_data_unref0 (td);
	_sqlite3_finalize0 (stmt);
	return result;
}


static gboolean magnatune_database_reader_real_get_stream_td_for_id (XnoiseDataSource* base, gint32 id, XnoiseTrackData** val, guint32 stamp) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData* _vala_val = NULL;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	guint32 _tmp1_ = 0U;
	guint32 _tmp2_;
	gint32 _tmp3_;
	guint32 _tmp4_;
	XnoiseTrackData* _tmp5_ = NULL;
	XnoiseTrackData* _tmp6_;
	self = (MagnatuneDatabaseReader*) base;
	_tmp0_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp1_ = xnoise_get_current_stamp (_tmp0_);
	_tmp2_ = stamp;
	g_return_val_if_fail (_tmp1_ == _tmp2_, FALSE);
	_tmp3_ = id;
	_tmp4_ = stamp;
	_tmp5_ = xnoise_data_source_get_trackdata_by_titleid ((XnoiseDataSource*) self, "", _tmp3_, _tmp4_);
	_xnoise_track_data_unref0 (_vala_val);
	_vala_val = _tmp5_;
	_tmp6_ = _vala_val;
	if (_tmp6_ == NULL) {
		result = FALSE;
		if (val) {
			*val = _vala_val;
		} else {
			_xnoise_track_data_unref0 (_vala_val);
		}
		return result;
	}
	result = TRUE;
	if (val) {
		*val = _vala_val;
	} else {
		_xnoise_track_data_unref0 (_vala_val);
	}
	return result;
}


static void _vala_array_add8 (XnoiseTrackData*** array, int* length, int* size, XnoiseTrackData* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (XnoiseTrackData*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static XnoiseTrackData** magnatune_database_reader_real_get_all_tracks (XnoiseDataSource* base, const gchar* searchtext, int* result_length1) {
	MagnatuneDatabaseReader * self;
	XnoiseTrackData** result = NULL;
	sqlite3_stmt* stmt = NULL;
	XnoiseTrackData** _tmp0_ = NULL;
	XnoiseTrackData** retv;
	gint retv_length1;
	gint _retv_size_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* st;
	gint _tmp3_ = 0;
	guint32 _tmp4_ = 0U;
	guint stamp;
	sqlite3* _tmp5_;
	sqlite3_stmt* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	sqlite3_stmt* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	GDestroyNotify _tmp12_;
	gint _tmp13_ = 0;
	gboolean _tmp19_;
	gboolean _tmp25_;
	XnoiseTrackData** _tmp124_;
	gint _tmp124__length1;
	XnoiseTrackData** _tmp125_;
	gint _tmp125__length1;
	self = (MagnatuneDatabaseReader*) base;
	g_return_val_if_fail (searchtext != NULL, NULL);
	_tmp0_ = g_new0 (XnoiseTrackData*, 0 + 1);
	retv = _tmp0_;
	retv_length1 = 0;
	_retv_size_ = retv_length1;
	_tmp1_ = searchtext;
	_tmp2_ = g_strdup_printf ("%%%s%%", _tmp1_);
	st = _tmp2_;
	_tmp3_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
	_tmp4_ = xnoise_get_current_stamp (_tmp3_);
	stamp = (guint) _tmp4_;
	_tmp5_ = self->priv->db;
	sqlite3_prepare_v2 (_tmp5_, MAGNATUNE_DATABASE_READER_STMT_ALL_TRACKDATA, -1, &_tmp6_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp6_;
	_tmp9_ = stmt;
	_tmp10_ = st;
	_tmp11_ = g_strdup (_tmp10_);
	_tmp12_ = g_free;
	_tmp13_ = sqlite3_bind_text (_tmp9_, 1, _tmp11_, -1, _tmp12_);
	if (_tmp13_ != SQLITE_OK) {
		_tmp8_ = TRUE;
	} else {
		sqlite3_stmt* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		GDestroyNotify _tmp17_;
		gint _tmp18_ = 0;
		_tmp14_ = stmt;
		_tmp15_ = st;
		_tmp16_ = g_strdup (_tmp15_);
		_tmp17_ = g_free;
		_tmp18_ = sqlite3_bind_text (_tmp14_, 2, _tmp16_, -1, _tmp17_);
		_tmp8_ = _tmp18_ != SQLITE_OK;
	}
	_tmp19_ = _tmp8_;
	if (_tmp19_) {
		_tmp7_ = TRUE;
	} else {
		sqlite3_stmt* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		GDestroyNotify _tmp23_;
		gint _tmp24_ = 0;
		_tmp20_ = stmt;
		_tmp21_ = st;
		_tmp22_ = g_strdup (_tmp21_);
		_tmp23_ = g_free;
		_tmp24_ = sqlite3_bind_text (_tmp20_, 3, _tmp22_, -1, _tmp23_);
		_tmp7_ = _tmp24_ != SQLITE_OK;
	}
	_tmp25_ = _tmp7_;
	if (_tmp25_) {
		XnoiseTrackData** _tmp26_;
		gint _tmp26__length1;
		magnatune_database_reader_db_error (self);
		_tmp26_ = NULL;
		_tmp26__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp26__length1;
		}
		result = _tmp26_;
		_g_free0 (st);
		retv = (_vala_array_free (retv, retv_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
		_sqlite3_finalize0 (stmt);
		return result;
	}
	while (TRUE) {
		sqlite3_stmt* _tmp27_;
		gint _tmp28_ = 0;
		XnoiseTrackData* _tmp29_;
		XnoiseTrackData* val;
		XnoiseTrackData* _tmp30_;
		sqlite3_stmt* _tmp31_;
		const gchar* _tmp32_ = NULL;
		gchar* _tmp33_;
		XnoiseTrackData* _tmp34_;
		sqlite3_stmt* _tmp35_;
		const gchar* _tmp36_ = NULL;
		gchar* _tmp37_;
		XnoiseTrackData* _tmp38_;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_ = NULL;
		gchar* _tmp41_;
		XnoiseTrackData* _tmp42_;
		sqlite3_stmt* _tmp43_;
		gint _tmp44_ = 0;
		XnoiseTrackData* _tmp45_;
		sqlite3_stmt* _tmp46_;
		gint _tmp47_ = 0;
		XnoiseTrackData* _tmp48_;
		sqlite3_stmt* _tmp49_;
		gint _tmp50_ = 0;
		sqlite3_stmt* _tmp51_;
		const gchar* _tmp52_ = NULL;
		gchar* _tmp53_ = NULL;
		gchar* _tmp54_;
		sqlite3_stmt* _tmp55_;
		gint _tmp56_ = 0;
		XnoiseItem _tmp57_ = {0};
		XnoiseItem _tmp58_;
		XnoiseItem* _tmp59_;
		XnoiseTrackData* _tmp60_;
		XnoiseItem* _tmp61_;
		guint _tmp62_;
		XnoiseTrackData* _tmp63_;
		XnoiseItem* _tmp64_;
		gint _tmp65_ = 0;
		XnoiseTrackData* _tmp66_;
		sqlite3_stmt* _tmp67_;
		const gchar* _tmp68_ = NULL;
		gchar* _tmp69_;
		XnoiseTrackData* _tmp70_;
		sqlite3_stmt* _tmp71_;
		gint _tmp72_ = 0;
		gboolean _tmp73_ = FALSE;
		XnoiseTrackData* _tmp74_;
		const gchar* _tmp75_;
		gboolean _tmp78_;
		gboolean _tmp81_ = FALSE;
		XnoiseTrackData* _tmp82_;
		const gchar* _tmp83_;
		gboolean _tmp86_;
		gboolean _tmp89_ = FALSE;
		XnoiseTrackData* _tmp90_;
		const gchar* _tmp91_;
		gboolean _tmp94_;
		gboolean _tmp97_ = FALSE;
		XnoiseTrackData* _tmp98_;
		const gchar* _tmp99_;
		gboolean _tmp102_;
		XnoiseTrackData** _tmp121_;
		gint _tmp121__length1;
		XnoiseTrackData* _tmp122_;
		XnoiseTrackData* _tmp123_;
		_tmp27_ = stmt;
		_tmp28_ = sqlite3_step (_tmp27_);
		if (!(_tmp28_ == SQLITE_ROW)) {
			break;
		}
		_tmp29_ = xnoise_track_data_new ();
		val = _tmp29_;
		_tmp30_ = val;
		_tmp31_ = stmt;
		_tmp32_ = sqlite3_column_text (_tmp31_, 0);
		_tmp33_ = g_strdup (_tmp32_);
		_g_free0 (_tmp30_->artist);
		_tmp30_->artist = _tmp33_;
		_tmp34_ = val;
		_tmp35_ = stmt;
		_tmp36_ = sqlite3_column_text (_tmp35_, 1);
		_tmp37_ = g_strdup (_tmp36_);
		_g_free0 (_tmp34_->album);
		_tmp34_->album = _tmp37_;
		_tmp38_ = val;
		_tmp39_ = stmt;
		_tmp40_ = sqlite3_column_text (_tmp39_, 2);
		_tmp41_ = g_strdup (_tmp40_);
		_g_free0 (_tmp38_->title);
		_tmp38_->title = _tmp41_;
		_tmp42_ = val;
		_tmp43_ = stmt;
		_tmp44_ = sqlite3_column_int (_tmp43_, 3);
		_tmp42_->tracknumber = (guint) _tmp44_;
		_tmp45_ = val;
		_tmp46_ = stmt;
		_tmp47_ = sqlite3_column_int (_tmp46_, 6);
		_tmp45_->length = (gint32) _tmp47_;
		_tmp48_ = val;
		_tmp49_ = stmt;
		_tmp50_ = sqlite3_column_int (_tmp49_, 4);
		_tmp51_ = stmt;
		_tmp52_ = sqlite3_column_text (_tmp51_, 5);
		_tmp53_ = magnatune_database_reader_transform_mag_url (self, _tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = stmt;
		_tmp56_ = sqlite3_column_int (_tmp55_, 7);
		xnoise_item_init (&_tmp57_, (XnoiseItemType) _tmp50_, _tmp54_, (gint32) _tmp56_);
		_tmp58_ = _tmp57_;
		_tmp59_ = __xnoise_item_dup0 (&_tmp58_);
		__vala_XnoiseItem_free0 (_tmp48_->item);
		_tmp48_->item = _tmp59_;
		xnoise_item_destroy (&_tmp58_);
		_g_free0 (_tmp54_);
		_tmp60_ = val;
		_tmp61_ = _tmp60_->item;
		_tmp62_ = stamp;
		(*_tmp61_).stamp = (guint32) _tmp62_;
		_tmp63_ = val;
		_tmp64_ = _tmp63_->item;
		_tmp65_ = xnoise_data_source_get_source_id ((XnoiseDataSource*) self);
		(*_tmp64_).source_id = _tmp65_;
		_tmp66_ = val;
		_tmp67_ = stmt;
		_tmp68_ = sqlite3_column_text (_tmp67_, 8);
		_tmp69_ = g_strdup (_tmp68_);
		_g_free0 (_tmp66_->genre);
		_tmp66_->genre = _tmp69_;
		_tmp70_ = val;
		_tmp71_ = stmt;
		_tmp72_ = sqlite3_column_int (_tmp71_, 9);
		_tmp70_->year = (guint) _tmp72_;
		_tmp74_ = val;
		_tmp75_ = _tmp74_->artist;
		if (g_strcmp0 (_tmp75_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp73_ = TRUE;
		} else {
			XnoiseTrackData* _tmp76_;
			const gchar* _tmp77_;
			_tmp76_ = val;
			_tmp77_ = _tmp76_->artist;
			_tmp73_ = _tmp77_ == NULL;
		}
		_tmp78_ = _tmp73_;
		if (_tmp78_) {
			XnoiseTrackData* _tmp79_;
			gchar* _tmp80_;
			_tmp79_ = val;
			_tmp80_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ARTIST);
			_g_free0 (_tmp79_->artist);
			_tmp79_->artist = _tmp80_;
		}
		_tmp82_ = val;
		_tmp83_ = _tmp82_->album;
		if (g_strcmp0 (_tmp83_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp81_ = TRUE;
		} else {
			XnoiseTrackData* _tmp84_;
			const gchar* _tmp85_;
			_tmp84_ = val;
			_tmp85_ = _tmp84_->album;
			_tmp81_ = _tmp85_ == NULL;
		}
		_tmp86_ = _tmp81_;
		if (_tmp86_) {
			XnoiseTrackData* _tmp87_;
			gchar* _tmp88_;
			_tmp87_ = val;
			_tmp88_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_ALBUM);
			_g_free0 (_tmp87_->album);
			_tmp87_->album = _tmp88_;
		}
		_tmp90_ = val;
		_tmp91_ = _tmp90_->genre;
		if (g_strcmp0 (_tmp91_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp89_ = TRUE;
		} else {
			XnoiseTrackData* _tmp92_;
			const gchar* _tmp93_;
			_tmp92_ = val;
			_tmp93_ = _tmp92_->genre;
			_tmp89_ = _tmp93_ == NULL;
		}
		_tmp94_ = _tmp89_;
		if (_tmp94_) {
			XnoiseTrackData* _tmp95_;
			gchar* _tmp96_;
			_tmp95_ = val;
			_tmp96_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_GENRE);
			_g_free0 (_tmp95_->genre);
			_tmp95_->genre = _tmp96_;
		}
		_tmp98_ = val;
		_tmp99_ = _tmp98_->title;
		if (g_strcmp0 (_tmp99_, XNOISE_RESOURCES_EMPTYSTRING) == 0) {
			_tmp97_ = TRUE;
		} else {
			XnoiseTrackData* _tmp100_;
			const gchar* _tmp101_;
			_tmp100_ = val;
			_tmp101_ = _tmp100_->title;
			_tmp97_ = _tmp101_ == NULL;
		}
		_tmp102_ = _tmp97_;
		if (_tmp102_) {
			XnoiseTrackData* _tmp103_;
			gchar* _tmp104_;
			XnoiseTrackData* _tmp105_;
			XnoiseItem* _tmp106_;
			const gchar* _tmp107_;
			GFile* _tmp108_ = NULL;
			GFile* file;
			gchar* fileBasename = NULL;
			GFile* _tmp109_;
			XnoiseTrackData* _tmp118_;
			const gchar* _tmp119_;
			gchar* _tmp120_;
			_tmp103_ = val;
			_tmp104_ = g_strdup (XNOISE_RESOURCES_UNKNOWN_TITLE);
			_g_free0 (_tmp103_->title);
			_tmp103_->title = _tmp104_;
			_tmp105_ = val;
			_tmp106_ = _tmp105_->item;
			_tmp107_ = (*_tmp106_).uri;
			_tmp108_ = g_file_new_for_uri (_tmp107_);
			file = _tmp108_;
			_tmp109_ = file;
			if (_tmp109_ != NULL) {
				GFile* _tmp110_;
				gchar* _tmp111_ = NULL;
				gchar* _tmp112_;
				gchar* _tmp113_ = NULL;
				_tmp110_ = file;
				_tmp111_ = g_file_get_path (_tmp110_);
				_tmp112_ = _tmp111_;
				_tmp113_ = g_filename_display_basename (_tmp112_);
				_g_free0 (fileBasename);
				fileBasename = _tmp113_;
				_g_free0 (_tmp112_);
			} else {
				XnoiseTrackData* _tmp114_;
				XnoiseItem* _tmp115_;
				const gchar* _tmp116_;
				gchar* _tmp117_;
				_tmp114_ = val;
				_tmp115_ = _tmp114_->item;
				_tmp116_ = (*_tmp115_).uri;
				_tmp117_ = g_strdup (_tmp116_);
				_g_free0 (fileBasename);
				fileBasename = _tmp117_;
			}
			_tmp118_ = val;
			_tmp119_ = fileBasename;
			_tmp120_ = g_strdup (_tmp119_);
			_g_free0 (_tmp118_->title);
			_tmp118_->title = _tmp120_;
			_g_free0 (fileBasename);
			_g_object_unref0 (file);
		}
		_tmp121_ = retv;
		_tmp121__length1 = retv_length1;
		_tmp122_ = val;
		_tmp123_ = _xnoise_track_data_ref0 (_tmp122_);
		_vala_array_add8 (&retv, &retv_length1, &_retv_size_, _tmp123_);
		_xnoise_track_data_unref0 (val);
	}
	_tmp124_ = retv;
	_tmp124__length1 = retv_length1;
	retv = NULL;
	_tmp125_ = _tmp124_;
	_tmp125__length1 = _tmp124__length1;
	if (result_length1) {
		*result_length1 = _tmp125__length1;
	}
	result = _tmp125_;
	_g_free0 (st);
	retv = (_vala_array_free (retv, retv_length1, (GDestroyNotify) xnoise_track_data_unref), NULL);
	_sqlite3_finalize0 (stmt);
	return result;
}


const gchar* magnatune_database_reader_get_username (MagnatuneDatabaseReader* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_username;
	result = _tmp0_;
	return result;
}


void magnatune_database_reader_set_username (MagnatuneDatabaseReader* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp9_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_username);
	self->priv->_username = _tmp1_;
	_tmp5_ = self->priv->_username;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		_tmp6_ = self->priv->_username;
		_tmp4_ = g_strcmp0 (_tmp6_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		const gchar* _tmp8_;
		_tmp8_ = self->priv->_password;
		_tmp3_ = _tmp8_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp9_ = _tmp3_;
	if (_tmp9_) {
		const gchar* _tmp10_;
		_tmp10_ = self->priv->_password;
		_tmp2_ = g_strcmp0 (_tmp10_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp11_ = _tmp2_;
	if (_tmp11_) {
		magnatune_database_reader_set_login_data_available (self, TRUE);
	} else {
		magnatune_database_reader_set_login_data_available (self, FALSE);
	}
	g_object_notify ((GObject *) self, "username");
}


const gchar* magnatune_database_reader_get_password (MagnatuneDatabaseReader* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_password;
	result = _tmp0_;
	return result;
}


void magnatune_database_reader_set_password (MagnatuneDatabaseReader* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp9_;
	gboolean _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_password);
	self->priv->_password = _tmp1_;
	_tmp5_ = self->priv->_username;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		_tmp6_ = self->priv->_username;
		_tmp4_ = g_strcmp0 (_tmp6_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		const gchar* _tmp8_;
		_tmp8_ = self->priv->_password;
		_tmp3_ = _tmp8_ != NULL;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp9_ = _tmp3_;
	if (_tmp9_) {
		const gchar* _tmp10_;
		_tmp10_ = self->priv->_password;
		_tmp2_ = g_strcmp0 (_tmp10_, XNOISE_RESOURCES_EMPTYSTRING) != 0;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp11_ = _tmp2_;
	if (_tmp11_) {
		const gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		gchar* _tmp18_ = NULL;
		magnatune_database_reader_set_login_data_available (self, TRUE);
		_tmp12_ = self->priv->_username;
		_tmp13_ = g_uri_escape_string (_tmp12_, NULL, TRUE);
		_tmp14_ = _tmp13_;
		_tmp15_ = self->priv->_password;
		_tmp16_ = g_uri_escape_string (_tmp15_, NULL, TRUE);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strdup_printf ("http://%s:%s@download.magnatune.com", _tmp14_, _tmp17_);
		_g_free0 (self->priv->http_replacement);
		self->priv->http_replacement = _tmp18_;
		_g_free0 (_tmp17_);
		_g_free0 (_tmp14_);
	} else {
		magnatune_database_reader_set_login_data_available (self, FALSE);
	}
	g_object_notify ((GObject *) self, "password");
}


gboolean magnatune_database_reader_get_login_data_available (MagnatuneDatabaseReader* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_login_data_available;
	result = _tmp0_;
	return result;
}


void magnatune_database_reader_set_login_data_available (MagnatuneDatabaseReader* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_login_data_available = _tmp0_;
	g_object_notify ((GObject *) self, "login-data-available");
}


static void magnatune_database_reader_class_init (MagnatuneDatabaseReaderClass * klass) {
	magnatune_database_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MagnatuneDatabaseReaderPrivate));
	XNOISE_DATA_SOURCE_CLASS (klass)->get_datasource_name = magnatune_database_reader_real_get_datasource_name;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_for_uri = magnatune_database_reader_real_get_trackdata_for_uri;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_artists_with_search = magnatune_database_reader_real_get_artists_with_search;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_artistid = magnatune_database_reader_real_get_trackdata_by_artistid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_artistitem_by_artistid = magnatune_database_reader_real_get_artistitem_by_artistid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_albumid = magnatune_database_reader_real_get_trackdata_by_albumid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_albums_with_search = magnatune_database_reader_real_get_albums_with_search;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_trackdata_by_titleid = magnatune_database_reader_real_get_trackdata_by_titleid;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_stream_td_for_id = magnatune_database_reader_real_get_stream_td_for_id;
	XNOISE_DATA_SOURCE_CLASS (klass)->get_all_tracks = magnatune_database_reader_real_get_all_tracks;
	G_OBJECT_CLASS (klass)->get_property = _vala_magnatune_database_reader_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_magnatune_database_reader_set_property;
	G_OBJECT_CLASS (klass)->finalize = magnatune_database_reader_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAGNATUNE_DATABASE_READER_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAGNATUNE_DATABASE_READER_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE, g_param_spec_boolean ("login-data-available", "login-data-available", "login-data-available", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void magnatune_database_reader_instance_init (MagnatuneDatabaseReader * self) {
	self->priv = MAGNATUNE_DATABASE_READER_GET_PRIVATE (self);
}


static void magnatune_database_reader_finalize (GObject* obj) {
	MagnatuneDatabaseReader * self;
	self = MAGNATUNE_DATABASE_READER (obj);
	_g_free0 (self->priv->DATABASE);
	_g_free0 (self->priv->_username);
	_g_free0 (self->priv->_password);
	_g_free0 (self->priv->http_replacement);
	_g_object_unref0 (self->priv->cancel);
	_sqlite3_close0 (self->priv->db);
	_sqlite3_finalize0 (self->priv->get_artists_with_search_stmt);
	_sqlite3_finalize0 (self->priv->get_artists_with_search2_stmt);
	G_OBJECT_CLASS (magnatune_database_reader_parent_class)->finalize (obj);
}


GType magnatune_database_reader_get_type (void) {
	return magnatune_database_reader_type_id;
}


GType magnatune_database_reader_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (MagnatuneDatabaseReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) magnatune_database_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MagnatuneDatabaseReader), 0, (GInstanceInitFunc) magnatune_database_reader_instance_init, NULL };
	magnatune_database_reader_type_id = g_type_module_register_type (module, XNOISE_TYPE_DATA_SOURCE, "MagnatuneDatabaseReader", &g_define_type_info, 0);
	return magnatune_database_reader_type_id;
}


static void _vala_magnatune_database_reader_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MagnatuneDatabaseReader * self;
	self = MAGNATUNE_DATABASE_READER (object);
	switch (property_id) {
		case MAGNATUNE_DATABASE_READER_USERNAME:
		g_value_set_string (value, magnatune_database_reader_get_username (self));
		break;
		case MAGNATUNE_DATABASE_READER_PASSWORD:
		g_value_set_string (value, magnatune_database_reader_get_password (self));
		break;
		case MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE:
		g_value_set_boolean (value, magnatune_database_reader_get_login_data_available (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_magnatune_database_reader_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MagnatuneDatabaseReader * self;
	self = MAGNATUNE_DATABASE_READER (object);
	switch (property_id) {
		case MAGNATUNE_DATABASE_READER_USERNAME:
		magnatune_database_reader_set_username (self, g_value_get_string (value));
		break;
		case MAGNATUNE_DATABASE_READER_PASSWORD:
		magnatune_database_reader_set_password (self, g_value_get_string (value));
		break;
		case MAGNATUNE_DATABASE_READER_LOGIN_DATA_AVAILABLE:
		magnatune_database_reader_set_login_data_available (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



